import{S as ja,i as Aa,s as La,e as n,k as u,w as b,t as l,M as Ia,c as a,d as o,m,a as s,x as k,h as d,b as h,G as t,g,y as w,q as $,o as y,B as P,v as Oa,L as _o}from"../../chunks/vendor-hf-doc-builder.js";import{T as fo}from"../../chunks/Tip-hf-doc-builder.js";import{D as rt}from"../../chunks/Docstring-hf-doc-builder.js";import{C as it}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as ge}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as go}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Da(x){let i,T;return i=new it({props:{code:`from transformers import GPTNeoXConfig, GPTNeoXModel

# Initializing a GPTNeoX gpt-neox-20b style configuration
configuration = GPTNeoXConfig()

# Initializing a model (with random weights) from the gpt-neox-20b style configuration
model = GPTNeoXModel(configuration)
# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPTNeoXConfig, GPTNeoXModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a GPTNeoX gpt-neox-20b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = GPTNeoXConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model (with random weights) from the gpt-neox-20b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTNeoXModel(configuration)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){b(i.$$.fragment)},l(p){k(i.$$.fragment,p)},m(p,f){w(i,p,f),T=!0},p:_o,i(p){T||($(i.$$.fragment,p),T=!0)},o(p){y(i.$$.fragment,p),T=!1},d(p){P(i,p)}}}function Ba(x){let i,T,p,f,v;return f=new it({props:{code:`from transformers import GPTNeoXTokenizerFast

tokenizer = GPTNeoXTokenizerFast.from_pretrained("gpt2")
tokenizer("Hello world")["input_ids"]

tokenizer(" Hello world")["input_ids"]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPTNeoXTokenizerFast

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = GPTNeoXTokenizerFast.from_pretrained(<span class="hljs-string">&quot;gpt2&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer(<span class="hljs-string">&quot;Hello world&quot;</span>)[<span class="hljs-string">&quot;input_ids&quot;</span>]
[<span class="hljs-number">15496</span>, <span class="hljs-number">995</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer(<span class="hljs-string">&quot; Hello world&quot;</span>)[<span class="hljs-string">&quot;input_ids&quot;</span>]
[<span class="hljs-number">18435</span>, <span class="hljs-number">995</span>]`}}),{c(){i=n("p"),T=l("be encoded differently whether it is at the beginning of the sentence (without space) or not:"),p=u(),b(f.$$.fragment)},l(r){i=a(r,"P",{});var _=s(i);T=d(_,"be encoded differently whether it is at the beginning of the sentence (without space) or not:"),_.forEach(o),p=m(r),k(f.$$.fragment,r)},m(r,_){g(r,i,_),t(i,T),g(r,p,_),w(f,r,_),v=!0},p:_o,i(r){v||($(f.$$.fragment,r),v=!0)},o(r){y(f.$$.fragment,r),v=!1},d(r){r&&o(i),r&&o(p),P(f,r)}}}function Sa(x){let i,T,p,f,v,r,_,G;return{c(){i=n("p"),T=l("When used with "),p=n("code"),f=l("is_split_into_words=True"),v=l(", this tokenizer needs to be instantiated with "),r=n("code"),_=l("add_prefix_space=True"),G=l(".")},l(z){i=a(z,"P",{});var N=s(i);T=d(N,"When used with "),p=a(N,"CODE",{});var E=s(p);f=d(E,"is_split_into_words=True"),E.forEach(o),v=d(N,", this tokenizer needs to be instantiated with "),r=a(N,"CODE",{});var M=s(r);_=d(M,"add_prefix_space=True"),M.forEach(o),G=d(N,"."),N.forEach(o)},m(z,N){g(z,i,N),t(i,T),t(i,p),t(p,f),t(i,v),t(i,r),t(r,_),t(i,G)},d(z){z&&o(i)}}}function Wa(x){let i,T,p,f,v;return{c(){i=n("p"),T=l("Although the recipe for forward pass needs to be defined within this function, one should call the "),p=n("code"),f=l("Module"),v=l(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(r){i=a(r,"P",{});var _=s(i);T=d(_,"Although the recipe for forward pass needs to be defined within this function, one should call the "),p=a(_,"CODE",{});var G=s(p);f=d(G,"Module"),G.forEach(o),v=d(_,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),_.forEach(o)},m(r,_){g(r,i,_),t(i,T),t(i,p),t(p,f),t(i,v)},d(r){r&&o(i)}}}function Ha(x){let i,T,p,f,v,r,_,G;return{c(){i=n("p"),T=l(`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-neox-20b instead of trl-internal-testing/tiny-random-GPTNeoXForCausalLM. If you get out-of-memory when loading that checkpoint, you can try
adding `),p=n("code"),f=l('device_map="auto"'),v=l(" in the "),r=n("code"),_=l("from_pretrained"),G=l(" call.")},l(z){i=a(z,"P",{});var N=s(i);T=d(N,`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-neox-20b instead of trl-internal-testing/tiny-random-GPTNeoXForCausalLM. If you get out-of-memory when loading that checkpoint, you can try
adding `),p=a(N,"CODE",{});var E=s(p);f=d(E,'device_map="auto"'),E.forEach(o),v=d(N," in the "),r=a(N,"CODE",{});var M=s(r);_=d(M,"from_pretrained"),M.forEach(o),G=d(N," call."),N.forEach(o)},m(z,N){g(z,i,N),t(i,T),t(i,p),t(p,f),t(i,v),t(i,r),t(r,_),t(i,G)},d(z){z&&o(i)}}}function Ua(x){let i,T,p,f,v;return f=new it({props:{code:`from transformers import AutoTokenizer, GPTNeoXModel
import torch

tokenizer = AutoTokenizer.from_pretrained("trl-internal-testing/tiny-random-GPTNeoXForCausalLM")
model = GPTNeoXModel.from_pretrained("trl-internal-testing/tiny-random-GPTNeoXForCausalLM")

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")
outputs = model(**inputs)

last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTNeoXModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;trl-internal-testing/tiny-random-GPTNeoXForCausalLM&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTNeoXModel.from_pretrained(<span class="hljs-string">&quot;trl-internal-testing/tiny-random-GPTNeoXForCausalLM&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){i=n("p"),T=l("Example:"),p=u(),b(f.$$.fragment)},l(r){i=a(r,"P",{});var _=s(i);T=d(_,"Example:"),_.forEach(o),p=m(r),k(f.$$.fragment,r)},m(r,_){g(r,i,_),t(i,T),g(r,p,_),w(f,r,_),v=!0},p:_o,i(r){v||($(f.$$.fragment,r),v=!0)},o(r){y(f.$$.fragment,r),v=!1},d(r){r&&o(i),r&&o(p),P(f,r)}}}function Va(x){let i,T,p,f,v;return{c(){i=n("p"),T=l("Although the recipe for forward pass needs to be defined within this function, one should call the "),p=n("code"),f=l("Module"),v=l(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(r){i=a(r,"P",{});var _=s(i);T=d(_,"Although the recipe for forward pass needs to be defined within this function, one should call the "),p=a(_,"CODE",{});var G=s(p);f=d(G,"Module"),G.forEach(o),v=d(_,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),_.forEach(o)},m(r,_){g(r,i,_),t(i,T),t(i,p),t(p,f),t(i,v)},d(r){r&&o(i)}}}function Ja(x){let i,T,p,f,v;return f=new it({props:{code:`from transformers import AutoTokenizer, GPTNeoXForCausalLM, GPTNeoXConfig
import torch

tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-neox-20b")
config = GPTNeoXConfig.from_pretrained("EleutherAI/gpt-neox-20b")
config.is_decoder = True
model = GPTNeoXForCausalLM.from_pretrained("EleutherAI/gpt-neox-20b", config=config)

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")
outputs = model(**inputs)

prediction_logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTNeoXForCausalLM, GPTNeoXConfig
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neox-20b&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>config = GPTNeoXConfig.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neox-20b&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>config.is_decoder = <span class="hljs-literal">True</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTNeoXForCausalLM.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neox-20b&quot;</span>, config=config)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>prediction_logits = outputs.logits`}}),{c(){i=n("p"),T=l("Example:"),p=u(),b(f.$$.fragment)},l(r){i=a(r,"P",{});var _=s(i);T=d(_,"Example:"),_.forEach(o),p=m(r),k(f.$$.fragment,r)},m(r,_){g(r,i,_),t(i,T),g(r,p,_),w(f,r,_),v=!0},p:_o,i(r){v||($(f.$$.fragment,r),v=!0)},o(r){y(f.$$.fragment,r),v=!1},d(r){r&&o(i),r&&o(p),P(f,r)}}}function Ra(x){let i,T,p,f,v,r,_,G,z,N,E,M,lt,_e,To,dt,vo,jt,K,bo,Te,ko,wo,At,Q,$o,ve,yo,Po,Lt,Se,No,It,be,Ot,We,Go,Dt,O,Z,ct,ke,Xo,pt,xo,Bt,ee,zo,ht,Eo,Mo,St,we,Wt,D,te,ut,$e,Co,mt,Fo,Ht,He,ft,Ue,qo,Ut,B,oe,gt,ye,jo,_t,Ao,Vt,q,Pe,Lo,S,Io,Ve,Oo,Do,Ne,Bo,So,Wo,W,Ho,Je,Uo,Vo,Re,Jo,Ro,Yo,ne,Jt,H,ae,Tt,Ge,Ko,vt,Qo,Rt,X,Xe,Zo,xe,en,bt,tn,on,nn,kt,an,sn,se,rn,ze,ln,wt,dn,cn,pn,re,hn,Ee,un,Ye,mn,fn,Yt,U,ie,$t,Me,gn,yt,_n,Kt,A,Ce,Tn,Fe,vn,qe,bn,kn,wn,C,je,$n,V,yn,Ke,Pn,Nn,Pt,Gn,Xn,xn,le,zn,de,En,ce,Qt,J,pe,Nt,Ae,Mn,Gt,Cn,Zt,L,Le,Fn,R,qn,Xt,jn,An,Ie,Ln,In,On,j,Oe,Dn,Y,Bn,Qe,Sn,Wn,xt,Hn,Un,Vn,he,Jn,ue,eo;return r=new ge({}),_e=new ge({}),be=new it({props:{code:'model = GPTNeoXForCausalLM.from_pretrained("EleutherAI/gpt-neox-20b").half().cuda()',highlighted:'model = GPTNeoXForCausalLM.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neox-20b&quot;</span>).half().cuda()'}}),ke=new ge({}),we=new it({props:{code:`from transformers import GPTNeoXForCausalLM, GPTNeoXTokenizerFast

model = GPTNeoXForCausalLM.from_pretrained("EleutherAI/gpt-neox-20b")
tokenizer = GPTNeoXTokenizerFast.from_pretrained("EleutherAI/gpt-neox-20b")

prompt = "GPTNeoX20B is a 20B-parameter autoregressive Transformer model developed by EleutherAI."

input_ids = tokenizer(prompt, return_tensors="pt").input_ids

gen_tokens = model.generate(
    input_ids,
    do_sample=True,
    temperature=0.9,
    max_length=100,
)
gen_text = tokenizer.batch_decode(gen_tokens)[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPTNeoXForCausalLM, GPTNeoXTokenizerFast

<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTNeoXForCausalLM.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neox-20b&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = GPTNeoXTokenizerFast.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neox-20b&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;GPTNeoX20B is a 20B-parameter autoregressive Transformer model developed by EleutherAI.&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids

<span class="hljs-meta">&gt;&gt;&gt; </span>gen_tokens = model.generate(
<span class="hljs-meta">... </span>    input_ids,
<span class="hljs-meta">... </span>    do_sample=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>    temperature=<span class="hljs-number">0.9</span>,
<span class="hljs-meta">... </span>    max_length=<span class="hljs-number">100</span>,
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>gen_text = tokenizer.batch_decode(gen_tokens)[<span class="hljs-number">0</span>]`}}),$e=new ge({}),ye=new ge({}),Pe=new rt({props:{name:"class transformers.GPTNeoXConfig",anchor:"transformers.GPTNeoXConfig",parameters:[{name:"vocab_size",val:" = 50432"},{name:"hidden_size",val:" = 6144"},{name:"num_hidden_layers",val:" = 44"},{name:"num_attention_heads",val:" = 64"},{name:"intermediate_size",val:" = 24576"},{name:"hidden_act",val:" = 'gelu'"},{name:"rotary_pct",val:" = 0.25"},{name:"rotary_emb_base",val:" = 10000"},{name:"max_position_embeddings",val:" = 2048"},{name:"initializer_range",val:" = 0.02"},{name:"layer_norm_eps",val:" = 1e-05"},{name:"use_cache",val:" = True"},{name:"bos_token_id",val:" = 0"},{name:"eos_token_id",val:" = 2"},{name:"tie_word_embeddings",val:" = False"},{name:"use_parallel_residual",val:" = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.GPTNeoXConfig.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 50432) &#x2014;
Vocabulary size of the GPTNeoX model. Defines the number of different tokens that can be represented by the
<code>inputs_ids</code> passed when calling <a href="/docs/transformers/pr_22365/en/model_doc/gpt_neox#transformers.GPTNeoXModel">GPTNeoXModel</a>.`,name:"vocab_size"},{anchor:"transformers.GPTNeoXConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 6144) &#x2014;
Dimension of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.GPTNeoXConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 44) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.GPTNeoXConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 64) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.GPTNeoXConfig.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 24576) &#x2014;
Dimension of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the Transformer encoder.`,name:"intermediate_size"},{anchor:"transformers.GPTNeoXConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;selu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"hidden_act"},{anchor:"transformers.GPTNeoXConfig.rotary_pct",description:`<strong>rotary_pct</strong> (<code>float</code>, <em>optional</em>, defaults to 0.25) &#x2014;
percentage of hidden dimensions to allocate to rotary embeddings`,name:"rotary_pct"},{anchor:"transformers.GPTNeoXConfig.rotary_emb_base",description:`<strong>rotary_emb_base</strong> (<code>int</code>, <em>optional</em>, defaults to 10000) &#x2014;
base for computing rotary embeddings frequency`,name:"rotary_emb_base"},{anchor:"transformers.GPTNeoXConfig.max_position_embeddings",description:`<strong>max_position_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
The maximum sequence length that this model might ever be used with. Typically set this to something large
just in case (e.g., 512 or 1024 or 2048).`,name:"max_position_embeddings"},{anchor:"transformers.GPTNeoXConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-5) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.GPTNeoXConfig.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-12) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"},{anchor:"transformers.GPTNeoXConfig.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the model should return the last key/values attentions (not used by all models). Only
relevant if <code>config.is_decoder=True</code>.`,name:"use_cache"},{anchor:"transformers.GPTNeoXConfig.use_parallel_residual",description:`<strong>use_parallel_residual</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to use a &#x201C;parallel&#x201D; formulation in each Transformer layer, which can provide a slight training
speedup at large scales (e.g. 20B).
Example &#x2014;`,name:"use_parallel_residual"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/gpt_neox/configuration_gpt_neox.py#L29"}}),ne=new go({props:{anchor:"transformers.GPTNeoXConfig.example",$$slots:{default:[Da]},$$scope:{ctx:x}}}),Ge=new ge({}),Xe=new rt({props:{name:"class transformers.GPTNeoXTokenizerFast",anchor:"transformers.GPTNeoXTokenizerFast",parameters:[{name:"vocab_file",val:" = None"},{name:"merges_file",val:" = None"},{name:"tokenizer_file",val:" = None"},{name:"unk_token",val:" = '<|endoftext|>'"},{name:"bos_token",val:" = '<|endoftext|>'"},{name:"eos_token",val:" = '<|endoftext|>'"},{name:"add_prefix_space",val:" = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.GPTNeoXTokenizerFast.vocab_file",description:`<strong>vocab_file</strong> (<code>str</code>) &#x2014;
Path to the vocabulary file.`,name:"vocab_file"},{anchor:"transformers.GPTNeoXTokenizerFast.merges_file",description:`<strong>merges_file</strong> (<code>str</code>) &#x2014;
Path to the merges file.`,name:"merges_file"},{anchor:"transformers.GPTNeoXTokenizerFast.errors",description:`<strong>errors</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;replace&quot;</code>) &#x2014;
Paradigm to follow when decoding bytes to UTF-8. See
<a href="https://docs.python.org/3/library/stdtypes.html#bytes.decode" rel="nofollow">bytes.decode</a> for more information.`,name:"errors"},{anchor:"transformers.GPTNeoXTokenizerFast.unk_token",description:`<strong>unk_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&lt;|endoftext|&gt;</code>) &#x2014;
The unknown token. A token that is not in the vocabulary cannot be converted to an ID and is set to be this
token instead.`,name:"unk_token"},{anchor:"transformers.GPTNeoXTokenizerFast.bos_token",description:`<strong>bos_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&lt;|endoftext|&gt;</code>) &#x2014;
The beginning of sequence token.`,name:"bos_token"},{anchor:"transformers.GPTNeoXTokenizerFast.eos_token",description:`<strong>eos_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&lt;|endoftext|&gt;</code>) &#x2014;
The end of sequence token.`,name:"eos_token"},{anchor:"transformers.GPTNeoXTokenizerFast.add_prefix_space",description:`<strong>add_prefix_space</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to add an initial space to the input. This allows to treat the leading word just as any
other word. (GPTNeoX tokenizer detect beginning of words by the preceding space).`,name:"add_prefix_space"},{anchor:"transformers.GPTNeoXTokenizerFast.trim_offsets",description:`<strong>trim_offsets</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the post-processing step should trim offsets to avoid including whitespaces.`,name:"trim_offsets"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/gpt_neox/tokenization_gpt_neox_fast.py#L44"}}),se=new go({props:{anchor:"transformers.GPTNeoXTokenizerFast.example",$$slots:{default:[Ba]},$$scope:{ctx:x}}}),re=new fo({props:{$$slots:{default:[Sa]},$$scope:{ctx:x}}}),Me=new ge({}),Ce=new rt({props:{name:"class transformers.GPTNeoXModel",anchor:"transformers.GPTNeoXModel",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.GPTNeoXModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22365/en/model_doc/gpt_neox#transformers.GPTNeoXConfig">~GPTNeoXConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22365/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/gpt_neox/modeling_gpt_neox.py#L402"}}),je=new rt({props:{name:"forward",anchor:"transformers.GPTNeoXModel.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.GPTNeoXModel.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_22365/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_22365/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_22365/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.GPTNeoXModel.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.GPTNeoXModel.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.GPTNeoXModel.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <em>input_ids</em> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.GPTNeoXModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.GPTNeoXModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.GPTNeoXModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22365/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.GPTNeoXModel.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code> of length <code>config.n_layers</code> with each tuple having 4 tensors of shape <code>(batch_size, num_heads, sequence_length - 1, embed_size_per_head)</code>) &#x2014;
Contains precomputed key and value hidden states of the attention blocks. Can be used to speed up decoding.
If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.GPTNeoXModel.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/gpt_neox/modeling_gpt_neox.py#L422",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22365/en/main_classes/output#transformers.modeling_outputs.BaseModelOutputWithPast"
>transformers.modeling_outputs.BaseModelOutputWithPast</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22365/en/model_doc/gpt_neox#transformers.GPTNeoXConfig"
>GPTNeoXConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
<p>If <code>past_key_values</code> is used only the last hidden-state of the sequences of shape <code>(batch_size, 1, hidden_size)</code> is output.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and optionally if
<code>config.is_encoder_decoder=True</code> 2 additional tensors of shape <code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and optionally if
<code>config.is_encoder_decoder=True</code> in the cross-attention blocks) that can be used (see <code>past_key_values</code>
input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22365/en/main_classes/output#transformers.modeling_outputs.BaseModelOutputWithPast"
>transformers.modeling_outputs.BaseModelOutputWithPast</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),le=new fo({props:{$$slots:{default:[Wa]},$$scope:{ctx:x}}}),de=new fo({props:{warning:!0,$$slots:{default:[Ha]},$$scope:{ctx:x}}}),ce=new go({props:{anchor:"transformers.GPTNeoXModel.forward.example",$$slots:{default:[Ua]},$$scope:{ctx:x}}}),Ae=new ge({}),Le=new rt({props:{name:"class transformers.GPTNeoXForCausalLM",anchor:"transformers.GPTNeoXForCausalLM",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.GPTNeoXForCausalLM.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22365/en/model_doc/gpt_neox#transformers.GPTNeoXConfig">~GPTNeoXConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22365/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/gpt_neox/modeling_gpt_neox.py#L566"}}),Oe=new rt({props:{name:"forward",anchor:"transformers.GPTNeoXForCausalLM.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.GPTNeoXForCausalLM.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_22365/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_22365/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_22365/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.GPTNeoXForCausalLM.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.GPTNeoXForCausalLM.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.GPTNeoXForCausalLM.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <em>input_ids</em> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.GPTNeoXForCausalLM.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.GPTNeoXForCausalLM.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.GPTNeoXForCausalLM.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22365/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.GPTNeoXForCausalLM.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) &#x2014;
Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and 2 additional tensors of shape
<code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>. The two additional tensors are
only required when the model is used as a decoder in a Sequence to Sequence model.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.GPTNeoXForCausalLM.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for computing the left-to-right language modeling loss (next word prediction). Indices should be in
<code>[-100, 0, ..., config.vocab_size]</code> (see <code>input_ids</code> docstring) Tokens with indices set to <code>-100</code> are
ignored (masked), the loss is only computed for the tokens with labels n <code>[0, ..., config.vocab_size]</code>.`,name:"labels"},{anchor:"transformers.GPTNeoXForCausalLM.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/gpt_neox/modeling_gpt_neox.py#L584",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22365/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithPast"
>transformers.modeling_outputs.CausalLMOutputWithPast</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22365/en/model_doc/gpt_neox#transformers.GPTNeoXConfig"
>GPTNeoXConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Language modeling loss (for next-token prediction).</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>)</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22365/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithPast"
>transformers.modeling_outputs.CausalLMOutputWithPast</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),he=new fo({props:{$$slots:{default:[Va]},$$scope:{ctx:x}}}),ue=new go({props:{anchor:"transformers.GPTNeoXForCausalLM.forward.example",$$slots:{default:[Ja]},$$scope:{ctx:x}}}),{c(){i=n("meta"),T=u(),p=n("h1"),f=n("a"),v=n("span"),b(r.$$.fragment),_=u(),G=n("span"),z=l("GPT-NeoX"),N=u(),E=n("h2"),M=n("a"),lt=n("span"),b(_e.$$.fragment),To=u(),dt=n("span"),vo=l("Overview"),jt=u(),K=n("p"),bo=l(`We introduce GPT-NeoX-20B, a 20 billion parameter autoregressive language model trained on the Pile, whose weights will
be made freely and openly available to the public through a permissive license. It is, to the best of our knowledge,
the largest dense autoregressive model that has publicly available weights at the time of submission. In this work,
we describe GPT-NeoX-20B\u2019s architecture and training and evaluate its performance on a range of language-understanding,
mathematics, and knowledge-based tasks. We find that GPT-NeoX-20B is a particularly powerful few-shot reasoner and
gains far more in performance when evaluated five-shot than similarly sized GPT-3 and FairSeq models. We open-source
the training and evaluation code, as well as the model weights, at `),Te=n("a"),ko=l("https://github.com/EleutherAI/gpt-neox"),wo=l("."),At=u(),Q=n("p"),$o=l(`Development of the model was led by Sid Black, Stella Biderman and Eric Hallahan, and the model was trained with
generous the support of `),ve=n("a"),yo=l("CoreWeave"),Po=l("."),Lt=u(),Se=n("p"),No=l("GPT-NeoX-20B was trained with fp16, thus it is recommended to initialize the model as follows:"),It=u(),b(be.$$.fragment),Ot=u(),We=n("p"),Go=l(`GPT-NeoX-20B also has a different tokenizer from the one used in GPT-J-6B and GPT-Neo. The new tokenizer allocates
additional tokens to whitespace characters, making the model more suitable for certain tasks like code generation.`),Dt=u(),O=n("h3"),Z=n("a"),ct=n("span"),b(ke.$$.fragment),Xo=u(),pt=n("span"),xo=l("Generation"),Bt=u(),ee=n("p"),zo=l("The "),ht=n("code"),Eo=l("generate()"),Mo=l(" method can be used to generate text using GPT Neo model."),St=u(),b(we.$$.fragment),Wt=u(),D=n("h2"),te=n("a"),ut=n("span"),b($e.$$.fragment),Co=u(),mt=n("span"),Fo=l("Documentation resources"),Ht=u(),He=n("ul"),ft=n("li"),Ue=n("a"),qo=l("Causal language modeling task guide"),Ut=u(),B=n("h2"),oe=n("a"),gt=n("span"),b(ye.$$.fragment),jo=u(),_t=n("span"),Ao=l("GPTNeoXConfig"),Vt=u(),q=n("div"),b(Pe.$$.fragment),Lo=u(),S=n("p"),Io=l("This is the configuration class to store the configuration of a "),Ve=n("a"),Oo=l("GPTNeoXModel"),Do=l(`. It is used to instantiate an
GPTNeoX model according to the specified arguments, defining the model architecture. Instantiating a configuration
with the defaults will yield a similar configuration to that of the GPTNeoX
`),Ne=n("a"),Bo=l("EleutherAI/gpt-neox-20b"),So=l(" architecture."),Wo=u(),W=n("p"),Ho=l("Configuration objects inherit from "),Je=n("a"),Uo=l("PretrainedConfig"),Vo=l(` and can be used to control the model outputs. Read the
documentation from `),Re=n("a"),Jo=l("PretrainedConfig"),Ro=l(" for more information."),Yo=u(),b(ne.$$.fragment),Jt=u(),H=n("h2"),ae=n("a"),Tt=n("span"),b(Ge.$$.fragment),Ko=u(),vt=n("span"),Qo=l("GPTNeoXTokenizerFast"),Rt=u(),X=n("div"),b(Xe.$$.fragment),Zo=u(),xe=n("p"),en=l("Construct a \u201Cfast\u201D GPT-NeoX-20B tokenizer (backed by HuggingFace\u2019s "),bt=n("em"),tn=l("tokenizers"),on=l(` library). Based on byte-level
Byte-Pair-Encoding.`),nn=u(),kt=n("p"),an=l("This tokenizer has been trained to treat spaces like parts of the tokens (a bit like sentencepiece) so a word will"),sn=u(),b(se.$$.fragment),rn=u(),ze=n("p"),ln=l("You can get around that behavior by passing "),wt=n("code"),dn=l("add_prefix_space=True"),cn=l(` when instantiating this tokenizer, but since
the model was not pretrained this way, it might yield a decrease in performance.`),pn=u(),b(re.$$.fragment),hn=u(),Ee=n("p"),un=l("This tokenizer inherits from "),Ye=n("a"),mn=l("PreTrainedTokenizerFast"),fn=l(` which contains most of the main methods. Users should
refer to this superclass for more information regarding those methods.`),Yt=u(),U=n("h2"),ie=n("a"),$t=n("span"),b(Me.$$.fragment),gn=u(),yt=n("span"),_n=l("GPTNeoXModel"),Kt=u(),A=n("div"),b(Ce.$$.fragment),Tn=u(),Fe=n("p"),vn=l(`The bare GPTNeoX Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),qe=n("a"),bn=l("torch.nn.Module"),kn=l(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),wn=u(),C=n("div"),b(je.$$.fragment),$n=u(),V=n("p"),yn=l("The "),Ke=n("a"),Pn=l("GPTNeoXModel"),Nn=l(" forward method, overrides the "),Pt=n("code"),Gn=l("__call__"),Xn=l(" special method."),xn=u(),b(le.$$.fragment),zn=u(),b(de.$$.fragment),En=u(),b(ce.$$.fragment),Qt=u(),J=n("h2"),pe=n("a"),Nt=n("span"),b(Ae.$$.fragment),Mn=u(),Gt=n("span"),Cn=l("GPTNeoXForCausalLM"),Zt=u(),L=n("div"),b(Le.$$.fragment),Fn=u(),R=n("p"),qn=l("GPTNeoX Model with a "),Xt=n("code"),jn=l("language modeling"),An=l(` head on top for CLM fine-tuning.
This model is a PyTorch `),Ie=n("a"),Ln=l("torch.nn.Module"),In=l(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),On=u(),j=n("div"),b(Oe.$$.fragment),Dn=u(),Y=n("p"),Bn=l("The "),Qe=n("a"),Sn=l("GPTNeoXForCausalLM"),Wn=l(" forward method, overrides the "),xt=n("code"),Hn=l("__call__"),Un=l(" special method."),Vn=u(),b(he.$$.fragment),Jn=u(),b(ue.$$.fragment),this.h()},l(e){const c=Ia('[data-svelte="svelte-1phssyn"]',document.head);i=a(c,"META",{name:!0,content:!0}),c.forEach(o),T=m(e),p=a(e,"H1",{class:!0});var De=s(p);f=a(De,"A",{id:!0,class:!0,href:!0});var zt=s(f);v=a(zt,"SPAN",{});var Et=s(v);k(r.$$.fragment,Et),Et.forEach(o),zt.forEach(o),_=m(De),G=a(De,"SPAN",{});var Mt=s(G);z=d(Mt,"GPT-NeoX"),Mt.forEach(o),De.forEach(o),N=m(e),E=a(e,"H2",{class:!0});var Be=s(E);M=a(Be,"A",{id:!0,class:!0,href:!0});var Ct=s(M);lt=a(Ct,"SPAN",{});var Ft=s(lt);k(_e.$$.fragment,Ft),Ft.forEach(o),Ct.forEach(o),To=m(Be),dt=a(Be,"SPAN",{});var qt=s(dt);vo=d(qt,"Overview"),qt.forEach(o),Be.forEach(o),jt=m(e),K=a(e,"P",{});var to=s(K);bo=d(to,`We introduce GPT-NeoX-20B, a 20 billion parameter autoregressive language model trained on the Pile, whose weights will
be made freely and openly available to the public through a permissive license. It is, to the best of our knowledge,
the largest dense autoregressive model that has publicly available weights at the time of submission. In this work,
we describe GPT-NeoX-20B\u2019s architecture and training and evaluate its performance on a range of language-understanding,
mathematics, and knowledge-based tasks. We find that GPT-NeoX-20B is a particularly powerful few-shot reasoner and
gains far more in performance when evaluated five-shot than similarly sized GPT-3 and FairSeq models. We open-source
the training and evaluation code, as well as the model weights, at `),Te=a(to,"A",{href:!0,rel:!0});var Rn=s(Te);ko=d(Rn,"https://github.com/EleutherAI/gpt-neox"),Rn.forEach(o),wo=d(to,"."),to.forEach(o),At=m(e),Q=a(e,"P",{});var oo=s(Q);$o=d(oo,`Development of the model was led by Sid Black, Stella Biderman and Eric Hallahan, and the model was trained with
generous the support of `),ve=a(oo,"A",{href:!0,rel:!0});var Yn=s(ve);yo=d(Yn,"CoreWeave"),Yn.forEach(o),Po=d(oo,"."),oo.forEach(o),Lt=m(e),Se=a(e,"P",{});var Kn=s(Se);No=d(Kn,"GPT-NeoX-20B was trained with fp16, thus it is recommended to initialize the model as follows:"),Kn.forEach(o),It=m(e),k(be.$$.fragment,e),Ot=m(e),We=a(e,"P",{});var Qn=s(We);Go=d(Qn,`GPT-NeoX-20B also has a different tokenizer from the one used in GPT-J-6B and GPT-Neo. The new tokenizer allocates
additional tokens to whitespace characters, making the model more suitable for certain tasks like code generation.`),Qn.forEach(o),Dt=m(e),O=a(e,"H3",{class:!0});var no=s(O);Z=a(no,"A",{id:!0,class:!0,href:!0});var Zn=s(Z);ct=a(Zn,"SPAN",{});var ea=s(ct);k(ke.$$.fragment,ea),ea.forEach(o),Zn.forEach(o),Xo=m(no),pt=a(no,"SPAN",{});var ta=s(pt);xo=d(ta,"Generation"),ta.forEach(o),no.forEach(o),Bt=m(e),ee=a(e,"P",{});var ao=s(ee);zo=d(ao,"The "),ht=a(ao,"CODE",{});var oa=s(ht);Eo=d(oa,"generate()"),oa.forEach(o),Mo=d(ao," method can be used to generate text using GPT Neo model."),ao.forEach(o),St=m(e),k(we.$$.fragment,e),Wt=m(e),D=a(e,"H2",{class:!0});var so=s(D);te=a(so,"A",{id:!0,class:!0,href:!0});var na=s(te);ut=a(na,"SPAN",{});var aa=s(ut);k($e.$$.fragment,aa),aa.forEach(o),na.forEach(o),Co=m(so),mt=a(so,"SPAN",{});var sa=s(mt);Fo=d(sa,"Documentation resources"),sa.forEach(o),so.forEach(o),Ht=m(e),He=a(e,"UL",{});var ra=s(He);ft=a(ra,"LI",{});var ia=s(ft);Ue=a(ia,"A",{href:!0});var la=s(Ue);qo=d(la,"Causal language modeling task guide"),la.forEach(o),ia.forEach(o),ra.forEach(o),Ut=m(e),B=a(e,"H2",{class:!0});var ro=s(B);oe=a(ro,"A",{id:!0,class:!0,href:!0});var da=s(oe);gt=a(da,"SPAN",{});var ca=s(gt);k(ye.$$.fragment,ca),ca.forEach(o),da.forEach(o),jo=m(ro),_t=a(ro,"SPAN",{});var pa=s(_t);Ao=d(pa,"GPTNeoXConfig"),pa.forEach(o),ro.forEach(o),Vt=m(e),q=a(e,"DIV",{class:!0});var me=s(q);k(Pe.$$.fragment,me),Lo=m(me),S=a(me,"P",{});var Ze=s(S);Io=d(Ze,"This is the configuration class to store the configuration of a "),Ve=a(Ze,"A",{href:!0});var ha=s(Ve);Oo=d(ha,"GPTNeoXModel"),ha.forEach(o),Do=d(Ze,`. It is used to instantiate an
GPTNeoX model according to the specified arguments, defining the model architecture. Instantiating a configuration
with the defaults will yield a similar configuration to that of the GPTNeoX
`),Ne=a(Ze,"A",{href:!0,rel:!0});var ua=s(Ne);Bo=d(ua,"EleutherAI/gpt-neox-20b"),ua.forEach(o),So=d(Ze," architecture."),Ze.forEach(o),Wo=m(me),W=a(me,"P",{});var et=s(W);Ho=d(et,"Configuration objects inherit from "),Je=a(et,"A",{href:!0});var ma=s(Je);Uo=d(ma,"PretrainedConfig"),ma.forEach(o),Vo=d(et,` and can be used to control the model outputs. Read the
documentation from `),Re=a(et,"A",{href:!0});var fa=s(Re);Jo=d(fa,"PretrainedConfig"),fa.forEach(o),Ro=d(et," for more information."),et.forEach(o),Yo=m(me),k(ne.$$.fragment,me),me.forEach(o),Jt=m(e),H=a(e,"H2",{class:!0});var io=s(H);ae=a(io,"A",{id:!0,class:!0,href:!0});var ga=s(ae);Tt=a(ga,"SPAN",{});var _a=s(Tt);k(Ge.$$.fragment,_a),_a.forEach(o),ga.forEach(o),Ko=m(io),vt=a(io,"SPAN",{});var Ta=s(vt);Qo=d(Ta,"GPTNeoXTokenizerFast"),Ta.forEach(o),io.forEach(o),Rt=m(e),X=a(e,"DIV",{class:!0});var F=s(X);k(Xe.$$.fragment,F),Zo=m(F),xe=a(F,"P",{});var lo=s(xe);en=d(lo,"Construct a \u201Cfast\u201D GPT-NeoX-20B tokenizer (backed by HuggingFace\u2019s "),bt=a(lo,"EM",{});var va=s(bt);tn=d(va,"tokenizers"),va.forEach(o),on=d(lo,` library). Based on byte-level
Byte-Pair-Encoding.`),lo.forEach(o),nn=m(F),kt=a(F,"P",{});var ba=s(kt);an=d(ba,"This tokenizer has been trained to treat spaces like parts of the tokens (a bit like sentencepiece) so a word will"),ba.forEach(o),sn=m(F),k(se.$$.fragment,F),rn=m(F),ze=a(F,"P",{});var co=s(ze);ln=d(co,"You can get around that behavior by passing "),wt=a(co,"CODE",{});var ka=s(wt);dn=d(ka,"add_prefix_space=True"),ka.forEach(o),cn=d(co,` when instantiating this tokenizer, but since
the model was not pretrained this way, it might yield a decrease in performance.`),co.forEach(o),pn=m(F),k(re.$$.fragment,F),hn=m(F),Ee=a(F,"P",{});var po=s(Ee);un=d(po,"This tokenizer inherits from "),Ye=a(po,"A",{href:!0});var wa=s(Ye);mn=d(wa,"PreTrainedTokenizerFast"),wa.forEach(o),fn=d(po,` which contains most of the main methods. Users should
refer to this superclass for more information regarding those methods.`),po.forEach(o),F.forEach(o),Yt=m(e),U=a(e,"H2",{class:!0});var ho=s(U);ie=a(ho,"A",{id:!0,class:!0,href:!0});var $a=s(ie);$t=a($a,"SPAN",{});var ya=s($t);k(Me.$$.fragment,ya),ya.forEach(o),$a.forEach(o),gn=m(ho),yt=a(ho,"SPAN",{});var Pa=s(yt);_n=d(Pa,"GPTNeoXModel"),Pa.forEach(o),ho.forEach(o),Kt=m(e),A=a(e,"DIV",{class:!0});var tt=s(A);k(Ce.$$.fragment,tt),Tn=m(tt),Fe=a(tt,"P",{});var uo=s(Fe);vn=d(uo,`The bare GPTNeoX Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),qe=a(uo,"A",{href:!0,rel:!0});var Na=s(qe);bn=d(Na,"torch.nn.Module"),Na.forEach(o),kn=d(uo,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),uo.forEach(o),wn=m(tt),C=a(tt,"DIV",{class:!0});var I=s(C);k(je.$$.fragment,I),$n=m(I),V=a(I,"P",{});var ot=s(V);yn=d(ot,"The "),Ke=a(ot,"A",{href:!0});var Ga=s(Ke);Pn=d(Ga,"GPTNeoXModel"),Ga.forEach(o),Nn=d(ot," forward method, overrides the "),Pt=a(ot,"CODE",{});var Xa=s(Pt);Gn=d(Xa,"__call__"),Xa.forEach(o),Xn=d(ot," special method."),ot.forEach(o),xn=m(I),k(le.$$.fragment,I),zn=m(I),k(de.$$.fragment,I),En=m(I),k(ce.$$.fragment,I),I.forEach(o),tt.forEach(o),Qt=m(e),J=a(e,"H2",{class:!0});var mo=s(J);pe=a(mo,"A",{id:!0,class:!0,href:!0});var xa=s(pe);Nt=a(xa,"SPAN",{});var za=s(Nt);k(Ae.$$.fragment,za),za.forEach(o),xa.forEach(o),Mn=m(mo),Gt=a(mo,"SPAN",{});var Ea=s(Gt);Cn=d(Ea,"GPTNeoXForCausalLM"),Ea.forEach(o),mo.forEach(o),Zt=m(e),L=a(e,"DIV",{class:!0});var nt=s(L);k(Le.$$.fragment,nt),Fn=m(nt),R=a(nt,"P",{});var at=s(R);qn=d(at,"GPTNeoX Model with a "),Xt=a(at,"CODE",{});var Ma=s(Xt);jn=d(Ma,"language modeling"),Ma.forEach(o),An=d(at,` head on top for CLM fine-tuning.
This model is a PyTorch `),Ie=a(at,"A",{href:!0,rel:!0});var Ca=s(Ie);Ln=d(Ca,"torch.nn.Module"),Ca.forEach(o),In=d(at,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),at.forEach(o),On=m(nt),j=a(nt,"DIV",{class:!0});var fe=s(j);k(Oe.$$.fragment,fe),Dn=m(fe),Y=a(fe,"P",{});var st=s(Y);Bn=d(st,"The "),Qe=a(st,"A",{href:!0});var Fa=s(Qe);Sn=d(Fa,"GPTNeoXForCausalLM"),Fa.forEach(o),Wn=d(st," forward method, overrides the "),xt=a(st,"CODE",{});var qa=s(xt);Hn=d(qa,"__call__"),qa.forEach(o),Un=d(st," special method."),st.forEach(o),Vn=m(fe),k(he.$$.fragment,fe),Jn=m(fe),k(ue.$$.fragment,fe),fe.forEach(o),nt.forEach(o),this.h()},h(){h(i,"name","hf:doc:metadata"),h(i,"content",JSON.stringify(Ya)),h(f,"id","gptneox"),h(f,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(f,"href","#gptneox"),h(p,"class","relative group"),h(M,"id","overview"),h(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(M,"href","#overview"),h(E,"class","relative group"),h(Te,"href","https://github.com/EleutherAI/gpt-neox"),h(Te,"rel","nofollow"),h(ve,"href","https://www.coreweave.com/"),h(ve,"rel","nofollow"),h(Z,"id","generation"),h(Z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Z,"href","#generation"),h(O,"class","relative group"),h(te,"id","documentation-resources"),h(te,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(te,"href","#documentation-resources"),h(D,"class","relative group"),h(Ue,"href","../tasks/language_modeling"),h(oe,"id","transformers.GPTNeoXConfig"),h(oe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(oe,"href","#transformers.GPTNeoXConfig"),h(B,"class","relative group"),h(Ve,"href","/docs/transformers/pr_22365/en/model_doc/gpt_neox#transformers.GPTNeoXModel"),h(Ne,"href","https://huggingface.co/EleutherAI/gpt-neox-20b"),h(Ne,"rel","nofollow"),h(Je,"href","/docs/transformers/pr_22365/en/main_classes/configuration#transformers.PretrainedConfig"),h(Re,"href","/docs/transformers/pr_22365/en/main_classes/configuration#transformers.PretrainedConfig"),h(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ae,"id","transformers.GPTNeoXTokenizerFast"),h(ae,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ae,"href","#transformers.GPTNeoXTokenizerFast"),h(H,"class","relative group"),h(Ye,"href","/docs/transformers/pr_22365/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast"),h(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ie,"id","transformers.GPTNeoXModel"),h(ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ie,"href","#transformers.GPTNeoXModel"),h(U,"class","relative group"),h(qe,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),h(qe,"rel","nofollow"),h(Ke,"href","/docs/transformers/pr_22365/en/model_doc/gpt_neox#transformers.GPTNeoXModel"),h(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(pe,"id","transformers.GPTNeoXForCausalLM"),h(pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(pe,"href","#transformers.GPTNeoXForCausalLM"),h(J,"class","relative group"),h(Ie,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),h(Ie,"rel","nofollow"),h(Qe,"href","/docs/transformers/pr_22365/en/model_doc/gpt_neox#transformers.GPTNeoXForCausalLM"),h(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,c){t(document.head,i),g(e,T,c),g(e,p,c),t(p,f),t(f,v),w(r,v,null),t(p,_),t(p,G),t(G,z),g(e,N,c),g(e,E,c),t(E,M),t(M,lt),w(_e,lt,null),t(E,To),t(E,dt),t(dt,vo),g(e,jt,c),g(e,K,c),t(K,bo),t(K,Te),t(Te,ko),t(K,wo),g(e,At,c),g(e,Q,c),t(Q,$o),t(Q,ve),t(ve,yo),t(Q,Po),g(e,Lt,c),g(e,Se,c),t(Se,No),g(e,It,c),w(be,e,c),g(e,Ot,c),g(e,We,c),t(We,Go),g(e,Dt,c),g(e,O,c),t(O,Z),t(Z,ct),w(ke,ct,null),t(O,Xo),t(O,pt),t(pt,xo),g(e,Bt,c),g(e,ee,c),t(ee,zo),t(ee,ht),t(ht,Eo),t(ee,Mo),g(e,St,c),w(we,e,c),g(e,Wt,c),g(e,D,c),t(D,te),t(te,ut),w($e,ut,null),t(D,Co),t(D,mt),t(mt,Fo),g(e,Ht,c),g(e,He,c),t(He,ft),t(ft,Ue),t(Ue,qo),g(e,Ut,c),g(e,B,c),t(B,oe),t(oe,gt),w(ye,gt,null),t(B,jo),t(B,_t),t(_t,Ao),g(e,Vt,c),g(e,q,c),w(Pe,q,null),t(q,Lo),t(q,S),t(S,Io),t(S,Ve),t(Ve,Oo),t(S,Do),t(S,Ne),t(Ne,Bo),t(S,So),t(q,Wo),t(q,W),t(W,Ho),t(W,Je),t(Je,Uo),t(W,Vo),t(W,Re),t(Re,Jo),t(W,Ro),t(q,Yo),w(ne,q,null),g(e,Jt,c),g(e,H,c),t(H,ae),t(ae,Tt),w(Ge,Tt,null),t(H,Ko),t(H,vt),t(vt,Qo),g(e,Rt,c),g(e,X,c),w(Xe,X,null),t(X,Zo),t(X,xe),t(xe,en),t(xe,bt),t(bt,tn),t(xe,on),t(X,nn),t(X,kt),t(kt,an),t(X,sn),w(se,X,null),t(X,rn),t(X,ze),t(ze,ln),t(ze,wt),t(wt,dn),t(ze,cn),t(X,pn),w(re,X,null),t(X,hn),t(X,Ee),t(Ee,un),t(Ee,Ye),t(Ye,mn),t(Ee,fn),g(e,Yt,c),g(e,U,c),t(U,ie),t(ie,$t),w(Me,$t,null),t(U,gn),t(U,yt),t(yt,_n),g(e,Kt,c),g(e,A,c),w(Ce,A,null),t(A,Tn),t(A,Fe),t(Fe,vn),t(Fe,qe),t(qe,bn),t(Fe,kn),t(A,wn),t(A,C),w(je,C,null),t(C,$n),t(C,V),t(V,yn),t(V,Ke),t(Ke,Pn),t(V,Nn),t(V,Pt),t(Pt,Gn),t(V,Xn),t(C,xn),w(le,C,null),t(C,zn),w(de,C,null),t(C,En),w(ce,C,null),g(e,Qt,c),g(e,J,c),t(J,pe),t(pe,Nt),w(Ae,Nt,null),t(J,Mn),t(J,Gt),t(Gt,Cn),g(e,Zt,c),g(e,L,c),w(Le,L,null),t(L,Fn),t(L,R),t(R,qn),t(R,Xt),t(Xt,jn),t(R,An),t(R,Ie),t(Ie,Ln),t(R,In),t(L,On),t(L,j),w(Oe,j,null),t(j,Dn),t(j,Y),t(Y,Bn),t(Y,Qe),t(Qe,Sn),t(Y,Wn),t(Y,xt),t(xt,Hn),t(Y,Un),t(j,Vn),w(he,j,null),t(j,Jn),w(ue,j,null),eo=!0},p(e,[c]){const De={};c&2&&(De.$$scope={dirty:c,ctx:e}),ne.$set(De);const zt={};c&2&&(zt.$$scope={dirty:c,ctx:e}),se.$set(zt);const Et={};c&2&&(Et.$$scope={dirty:c,ctx:e}),re.$set(Et);const Mt={};c&2&&(Mt.$$scope={dirty:c,ctx:e}),le.$set(Mt);const Be={};c&2&&(Be.$$scope={dirty:c,ctx:e}),de.$set(Be);const Ct={};c&2&&(Ct.$$scope={dirty:c,ctx:e}),ce.$set(Ct);const Ft={};c&2&&(Ft.$$scope={dirty:c,ctx:e}),he.$set(Ft);const qt={};c&2&&(qt.$$scope={dirty:c,ctx:e}),ue.$set(qt)},i(e){eo||($(r.$$.fragment,e),$(_e.$$.fragment,e),$(be.$$.fragment,e),$(ke.$$.fragment,e),$(we.$$.fragment,e),$($e.$$.fragment,e),$(ye.$$.fragment,e),$(Pe.$$.fragment,e),$(ne.$$.fragment,e),$(Ge.$$.fragment,e),$(Xe.$$.fragment,e),$(se.$$.fragment,e),$(re.$$.fragment,e),$(Me.$$.fragment,e),$(Ce.$$.fragment,e),$(je.$$.fragment,e),$(le.$$.fragment,e),$(de.$$.fragment,e),$(ce.$$.fragment,e),$(Ae.$$.fragment,e),$(Le.$$.fragment,e),$(Oe.$$.fragment,e),$(he.$$.fragment,e),$(ue.$$.fragment,e),eo=!0)},o(e){y(r.$$.fragment,e),y(_e.$$.fragment,e),y(be.$$.fragment,e),y(ke.$$.fragment,e),y(we.$$.fragment,e),y($e.$$.fragment,e),y(ye.$$.fragment,e),y(Pe.$$.fragment,e),y(ne.$$.fragment,e),y(Ge.$$.fragment,e),y(Xe.$$.fragment,e),y(se.$$.fragment,e),y(re.$$.fragment,e),y(Me.$$.fragment,e),y(Ce.$$.fragment,e),y(je.$$.fragment,e),y(le.$$.fragment,e),y(de.$$.fragment,e),y(ce.$$.fragment,e),y(Ae.$$.fragment,e),y(Le.$$.fragment,e),y(Oe.$$.fragment,e),y(he.$$.fragment,e),y(ue.$$.fragment,e),eo=!1},d(e){o(i),e&&o(T),e&&o(p),P(r),e&&o(N),e&&o(E),P(_e),e&&o(jt),e&&o(K),e&&o(At),e&&o(Q),e&&o(Lt),e&&o(Se),e&&o(It),P(be,e),e&&o(Ot),e&&o(We),e&&o(Dt),e&&o(O),P(ke),e&&o(Bt),e&&o(ee),e&&o(St),P(we,e),e&&o(Wt),e&&o(D),P($e),e&&o(Ht),e&&o(He),e&&o(Ut),e&&o(B),P(ye),e&&o(Vt),e&&o(q),P(Pe),P(ne),e&&o(Jt),e&&o(H),P(Ge),e&&o(Rt),e&&o(X),P(Xe),P(se),P(re),e&&o(Yt),e&&o(U),P(Me),e&&o(Kt),e&&o(A),P(Ce),P(je),P(le),P(de),P(ce),e&&o(Qt),e&&o(J),P(Ae),e&&o(Zt),e&&o(L),P(Le),P(Oe),P(he),P(ue)}}}const Ya={local:"gptneox",sections:[{local:"overview",sections:[{local:"generation",title:"Generation"}],title:"Overview"},{local:"documentation-resources",title:"Documentation resources"},{local:"transformers.GPTNeoXConfig",title:"GPTNeoXConfig"},{local:"transformers.GPTNeoXTokenizerFast",title:"GPTNeoXTokenizerFast"},{local:"transformers.GPTNeoXModel",title:"GPTNeoXModel"},{local:"transformers.GPTNeoXForCausalLM",title:"GPTNeoXForCausalLM"}],title:"GPT-NeoX"};function Ka(x){return Oa(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class as extends ja{constructor(i){super();Aa(this,i,Ka,Ra,La,{})}}export{as as default,Ya as metadata};
