import{S as pd,i as hd,s as fd,e as n,k as l,w as v,t as a,M as md,c as r,d as o,m as u,a as s,x as P,h as i,b as d,G as e,g as m,y as b,q as w,o as T,B as y,v as gd,L as Eo}from"../../chunks/vendor-hf-doc-builder.js";import{T as ji}from"../../chunks/Tip-hf-doc-builder.js";import{D as M}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Mo}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as H}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as zo}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function _d(k){let p,S,_,f,x;return f=new Mo({props:{code:`from transformers import Pix2StructConfig, Pix2StructModel

# Initializing a Pix2StructConfig with Salesforce/pix2struct-vqa-base style configuration
configuration = Pix2StructConfig()

# Initializing a Pix2StructPModel (with random weights) from the Salesforce/pix2struct-vqa-base style configuration
model = Pix2StructModel(configuration)

# Accessing the model configuration
configuration = model.config

# We can also initialize a Pix2StructConfig from a Pix2StructTextConfig and a Pix2StructVisionConfig

# Initializing a PIX2STRUCTText and PIX2STRUCTVision configuration
config_text = Pix2StructTextConfig()
config_vision = Pix2StructVisionConfig()

config = Pix2StructConfig.from_text_vision_configs(config_text, config_vision)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Pix2StructConfig, Pix2StructModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Pix2StructConfig with Salesforce/pix2struct-vqa-base style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = Pix2StructConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Pix2StructPModel (with random weights) from the Salesforce/pix2struct-vqa-base style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Pix2StructModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># We can also initialize a Pix2StructConfig from a Pix2StructTextConfig and a Pix2StructVisionConfig</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a PIX2STRUCTText and PIX2STRUCTVision configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>config_text = Pix2StructTextConfig()
<span class="hljs-meta">&gt;&gt;&gt; </span>config_vision = Pix2StructVisionConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span>config = Pix2StructConfig.from_text_vision_configs(config_text, config_vision)`}}),{c(){p=n("p"),S=a("Example:"),_=l(),v(f.$$.fragment)},l(c){p=r(c,"P",{});var g=s(p);S=i(g,"Example:"),g.forEach(o),_=u(c),P(f.$$.fragment,c)},m(c,g){m(c,p,g),e(p,S),m(c,_,g),b(f,c,g),x=!0},p:Eo,i(c){x||(w(f.$$.fragment,c),x=!0)},o(c){T(f.$$.fragment,c),x=!1},d(c){c&&o(p),c&&o(_),y(f,c)}}}function xd(k){let p,S,_,f,x;return f=new Mo({props:{code:`from transformers import Pix2StructTextConfig, Pix2StructTextModel

# Initializing a Pix2StructTextConfig with Salesforce/pix2struct-vqa-base style configuration
configuration = Pix2StructTextConfig()

# Initializing a Pix2StructTextModel (with random weights) from the Salesforce/pix2struct-vqa-base style configuration
model = Pix2StructTextModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Pix2StructTextConfig, Pix2StructTextModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Pix2StructTextConfig with Salesforce/pix2struct-vqa-base style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = Pix2StructTextConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Pix2StructTextModel (with random weights) from the Salesforce/pix2struct-vqa-base style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Pix2StructTextModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){p=n("p"),S=a("Example:"),_=l(),v(f.$$.fragment)},l(c){p=r(c,"P",{});var g=s(p);S=i(g,"Example:"),g.forEach(o),_=u(c),P(f.$$.fragment,c)},m(c,g){m(c,p,g),e(p,S),m(c,_,g),b(f,c,g),x=!0},p:Eo,i(c){x||(w(f.$$.fragment,c),x=!0)},o(c){T(f.$$.fragment,c),x=!1},d(c){c&&o(p),c&&o(_),y(f,c)}}}function vd(k){let p,S,_,f,x;return f=new Mo({props:{code:`from transformers import Pix2StructVisionConfig, Pix2StructVisionModel

# Initializing a Pix2StructVisionConfig with Salesforce/pix2struct-vqa-base style configuration
configuration = Pix2StructVisionConfig()

# Initializing a Pix2StructVisionModel (with random weights) from the Salesforce/pix2struct-vqa-base style configuration
model = Pix2StructVisionModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Pix2StructVisionConfig, Pix2StructVisionModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Pix2StructVisionConfig with Salesforce/pix2struct-vqa-base style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = Pix2StructVisionConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Pix2StructVisionModel (with random weights) from the Salesforce/pix2struct-vqa-base style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Pix2StructVisionModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){p=n("p"),S=a("Example:"),_=l(),v(f.$$.fragment)},l(c){p=r(c,"P",{});var g=s(p);S=i(g,"Example:"),g.forEach(o),_=u(c),P(f.$$.fragment,c)},m(c,g){m(c,p,g),e(p,S),m(c,_,g),b(f,c,g),x=!0},p:Eo,i(c){x||(w(f.$$.fragment,c),x=!0)},o(c){T(f.$$.fragment,c),x=!1},d(c){c&&o(p),c&&o(_),y(f,c)}}}function Pd(k){let p,S,_,f,x;return{c(){p=n("p"),S=a("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=n("code"),f=a("Module"),x=a(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(c){p=r(c,"P",{});var g=s(p);S=i(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=r(g,"CODE",{});var q=s(_);f=i(q,"Module"),q.forEach(o),x=i(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(o)},m(c,g){m(c,p,g),e(p,S),e(p,_),e(_,f),e(p,x)},d(c){c&&o(p)}}}function bd(k){let p,S,_,f,x;return f=new Mo({props:{code:`from transformers import AutoProcessor, Pix2StructTextModel

processor = AutoProcessor.from_pretrained("google/pix2struct-textcaps-base")
model = Pix2StructTextModel.from_pretrained("google/pix2struct-textcaps-base")

inputs = processor(text="Hello, my dog is cute", return_tensors="pt")
outputs = model(**inputs)
loss = outputs.loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoProcessor, Pix2StructTextModel

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;google/pix2struct-textcaps-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Pix2StructTextModel.from_pretrained(<span class="hljs-string">&quot;google/pix2struct-textcaps-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = processor(text=<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = outputs.loss`}}),{c(){p=n("p"),S=a("Example:"),_=l(),v(f.$$.fragment)},l(c){p=r(c,"P",{});var g=s(p);S=i(g,"Example:"),g.forEach(o),_=u(c),P(f.$$.fragment,c)},m(c,g){m(c,p,g),e(p,S),m(c,_,g),b(f,c,g),x=!0},p:Eo,i(c){x||(w(f.$$.fragment,c),x=!0)},o(c){T(f.$$.fragment,c),x=!1},d(c){c&&o(p),c&&o(_),y(f,c)}}}function wd(k){let p,S,_,f,x;return{c(){p=n("p"),S=a("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=n("code"),f=a("Module"),x=a(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(c){p=r(c,"P",{});var g=s(p);S=i(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=r(g,"CODE",{});var q=s(_);f=i(q,"Module"),q.forEach(o),x=i(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(o)},m(c,g){m(c,p,g),e(p,S),e(p,_),e(_,f),e(p,x)},d(c){c&&o(p)}}}function Td(k){let p,S,_,f,x;return f=new Mo({props:{code:`import requests
from PIL import Image
from transformers import AutoProcessor, Pix2StructVisionModel

image_processor = AutoProcessor.from_pretrained("google/pix2struct-textcaps-base")
model = Pix2StructVisionModel.from_pretrained("google/pix2struct-textcaps-base")

url = "https://www.ilankelman.org/stopsigns/australia.jpg"
image = Image.open(requests.get(url, stream=True).raw)

inputs = image_processor(images=image, return_tensors="pt")
with torch.no_grad():
    outputs = model(**inputs)

last_hidden_states = outputs.last_hidden_state
list(last_hidden_states.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoProcessor, Pix2StructVisionModel

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;google/pix2struct-textcaps-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Pix2StructVisionModel.from_pretrained(<span class="hljs-string">&quot;google/pix2struct-textcaps-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://www.ilankelman.org/stopsigns/australia.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">list</span>(last_hidden_states.shape)
[<span class="hljs-number">1</span>, <span class="hljs-number">2048</span>, <span class="hljs-number">768</span>]`}}),{c(){p=n("p"),S=a("Example:"),_=l(),v(f.$$.fragment)},l(c){p=r(c,"P",{});var g=s(p);S=i(g,"Example:"),g.forEach(o),_=u(c),P(f.$$.fragment,c)},m(c,g){m(c,p,g),e(p,S),m(c,_,g),b(f,c,g),x=!0},p:Eo,i(c){x||(w(f.$$.fragment,c),x=!0)},o(c){T(f.$$.fragment,c),x=!1},d(c){c&&o(p),c&&o(_),y(f,c)}}}function yd(k){let p,S,_,f,x;return{c(){p=n("p"),S=a("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=n("code"),f=a("Module"),x=a(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(c){p=r(c,"P",{});var g=s(p);S=i(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=r(g,"CODE",{});var q=s(_);f=i(q,"Module"),q.forEach(o),x=i(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(o)},m(c,g){m(c,p,g),e(p,S),e(p,_),e(_,f),e(p,x)},d(c){c&&o(p)}}}function Sd(k){let p,S,_,f,x;return f=new Mo({props:{code:`from PIL import Image
import requests
from transformers import AutoProcessor, Pix2StructForConditionalGeneration

processor = AutoProcessor.from_pretrained("google/pix2struct-textcaps-base")
model = Pix2StructForConditionalGeneration.from_pretrained("google/pix2struct-textcaps-base")

labels = "A stop sign is on the street corner."
url = "https://www.ilankelman.org/stopsigns/australia.jpg"
image = Image.open(requests.get(url, stream=True).raw)

inputs = processor(images=image, text=labels, return_tensors="pt", add_special_tokens=True)

# forward pass
outputs = model(**inputs)
last_hidden_states = outputs.loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoProcessor, Pix2StructForConditionalGeneration

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;google/pix2struct-textcaps-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Pix2StructForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;google/pix2struct-textcaps-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>labels = <span class="hljs-string">&quot;A stop sign is on the street corner.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://www.ilankelman.org/stopsigns/australia.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = processor(images=image, text=labels, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>, add_special_tokens=<span class="hljs-literal">True</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward pass</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.loss`}}),{c(){p=n("p"),S=a("Example:"),_=l(),v(f.$$.fragment)},l(c){p=r(c,"P",{});var g=s(p);S=i(g,"Example:"),g.forEach(o),_=u(c),P(f.$$.fragment,c)},m(c,g){m(c,p,g),e(p,S),m(c,_,g),b(f,c,g),x=!0},p:Eo,i(c){x||(w(f.$$.fragment,c),x=!0)},o(c){T(f.$$.fragment,c),x=!1},d(c){c&&o(p),c&&o(_),y(f,c)}}}function kd(k){let p,S,_,f,x,c,g,q,_r,wn,Z,ge,qo,He,xr,Io,vr,Tn,_e,Pr,Be,br,wr,yn,Ht,Tr,Sn,Bt,Fo,yr,kn,Kt,Sr,$n,Xt,kr,Cn,B,$r,Ke,Cr,zr,Xe,Er,Mr,zn,ee,xe,jo,Je,qr,Ao,Ir,En,K,Vo,Qe,Fr,jr,No,Ye,Ar,Vr,Do,Ze,Nr,Mn,te,ve,Oo,et,Dr,Lo,Or,qn,z,tt,Lr,X,Jt,Ur,Rr,Uo,Wr,Gr,ot,Hr,Br,Kr,oe,Xr,Qt,Jr,Qr,Yt,Yr,Zr,es,Pe,ts,be,nt,os,rt,ns,Zt,rs,ss,In,ne,we,Ro,st,as,Wo,is,Fn,F,at,cs,U,ds,eo,ls,us,Go,ps,hs,it,fs,ms,gs,re,_s,to,xs,vs,oo,Ps,bs,ws,Te,jn,se,ye,Ho,ct,Ts,Bo,ys,An,j,dt,Ss,ae,ks,no,$s,Cs,lt,zs,Es,Ms,ie,qs,ro,Is,Fs,so,js,As,Vs,Se,Vn,ce,ke,Ko,ut,Ns,Xo,Ds,Nn,E,pt,Os,Jo,Ls,Us,I,ao,Rs,Ws,io,Gs,Hs,co,Bs,Ks,Qo,Xs,Js,lo,Qs,Ys,Zs,$e,ht,ea,ft,ta,uo,oa,na,ra,Ce,mt,sa,gt,aa,po,ia,ca,Dn,de,ze,Yo,_t,da,Zo,la,On,R,xt,ua,en,pa,ha,Ee,vt,fa,A,ma,tn,ga,_a,on,xa,va,nn,Pa,ba,Pt,wa,Ta,Ln,le,Me,rn,bt,ya,sn,Sa,Un,$,wt,ka,an,$a,Ca,Tt,za,yt,Ea,Ma,qa,St,Ia,ho,Fa,ja,Aa,kt,Va,$t,Na,Da,Oa,V,Ct,La,ue,Ua,fo,Ra,Wa,cn,Ga,Ha,Ba,qe,Ka,Ie,Rn,pe,Fe,dn,zt,Xa,ln,Ja,Wn,W,Et,Qa,Mt,Ya,qt,Za,ei,ti,N,It,oi,he,ni,mo,ri,si,un,ai,ii,ci,je,di,Ae,Gn,fe,Ve,pn,Ft,li,hn,ui,Hn,C,jt,pi,fn,hi,fi,At,mi,Vt,gi,_i,xi,Nt,vi,go,Pi,bi,wi,Dt,Ti,Ot,yi,Si,ki,D,Lt,$i,me,Ci,_o,zi,Ei,mn,Mi,qi,Ii,Ne,Fi,De,Bn;return c=new H({}),He=new H({}),Je=new H({}),et=new H({}),tt=new M({props:{name:"class transformers.Pix2StructConfig",anchor:"transformers.Pix2StructConfig",parameters:[{name:"text_config",val:" = None"},{name:"vision_config",val:" = None"},{name:"initializer_factor",val:" = 1.0"},{name:"initializer_range",val:" = 0.02"},{name:"is_vqa",val:" = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Pix2StructConfig.text_config",description:`<strong>text_config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Dictionary of configuration options used to initialize <a href="/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructTextConfig">Pix2StructTextConfig</a>.`,name:"text_config"},{anchor:"transformers.Pix2StructConfig.vision_config",description:`<strong>vision_config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Dictionary of configuration options used to initialize <a href="/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructVisionConfig">Pix2StructVisionConfig</a>.`,name:"vision_config"},{anchor:"transformers.Pix2StructConfig.initializer_factor",description:`<strong>initializer_factor</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014;
Factor to multiply the initialization range with.`,name:"initializer_factor"},{anchor:"transformers.Pix2StructConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.Pix2StructConfig.is_vqa",description:`<strong>is_vqa</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the model has been fine-tuned for VQA or not.`,name:"is_vqa"},{anchor:"transformers.Pix2StructConfig.kwargs",description:`<strong>kwargs</strong> (<em>optional</em>) &#x2014;
Dictionary of keyword arguments.`,name:"kwargs"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/pix2struct/configuration_pix2struct.py#L302"}}),Pe=new zo({props:{anchor:"transformers.Pix2StructConfig.example",$$slots:{default:[_d]},$$scope:{ctx:k}}}),nt=new M({props:{name:"from_text_vision_configs",anchor:"transformers.Pix2StructConfig.from_text_vision_configs",parameters:[{name:"text_config",val:": Pix2StructTextConfig"},{name:"vision_config",val:": Pix2StructVisionConfig"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/pix2struct/configuration_pix2struct.py#L387",returnDescription:`
<p>An instance of a configuration object</p>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructConfig"
>Pix2StructConfig</a></p>
`}}),st=new H({}),at=new M({props:{name:"class transformers.Pix2StructTextConfig",anchor:"transformers.Pix2StructTextConfig",parameters:[{name:"vocab_size",val:" = 50244"},{name:"hidden_size",val:" = 768"},{name:"d_kv",val:" = 64"},{name:"d_ff",val:" = 2048"},{name:"num_layers",val:" = 12"},{name:"num_heads",val:" = 12"},{name:"relative_attention_num_buckets",val:" = 32"},{name:"relative_attention_max_distance",val:" = 128"},{name:"dropout_rate",val:" = 0.1"},{name:"layer_norm_epsilon",val:" = 1e-06"},{name:"initializer_factor",val:" = 1.0"},{name:"dense_act_fn",val:" = 'gelu_new'"},{name:"decoder_start_token_id",val:" = 0"},{name:"use_cache",val:" = False"},{name:"pad_token_id",val:" = 0"},{name:"eos_token_id",val:" = 1"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Pix2StructTextConfig.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 50244) &#x2014;
Vocabulary size of the <code>Pix2Struct</code> text model. Defines the number of different tokens that can be
represented by the <code>inputs_ids</code> passed when calling <code>Pix2StructModel</code>.`,name:"vocab_size"},{anchor:"transformers.Pix2StructTextConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
Dimensionality of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.Pix2StructTextConfig.d_kv",description:`<strong>d_kv</strong> (<code>int</code>, <em>optional</em>, defaults to 64) &#x2014;
Dimensionality of the key, query, value projections in each attention head.`,name:"d_kv"},{anchor:"transformers.Pix2StructTextConfig.d_ff",description:`<strong>d_ff</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the Transformer encoder.`,name:"d_ff"},{anchor:"transformers.Pix2StructTextConfig.num_layers",description:`<strong>num_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_layers"},{anchor:"transformers.Pix2StructTextConfig.num_heads",description:`<strong>num_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_heads"},{anchor:"transformers.Pix2StructTextConfig.relative_attention_num_buckets",description:`<strong>relative_attention_num_buckets</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014;
The number of buckets to use for each attention layer.`,name:"relative_attention_num_buckets"},{anchor:"transformers.Pix2StructTextConfig.relative_attention_max_distance",description:`<strong>relative_attention_max_distance</strong> (<code>int</code>, <em>optional</em>, defaults to 128) &#x2014;
The maximum distance of the longer sequences for the bucket separation.`,name:"relative_attention_max_distance"},{anchor:"transformers.Pix2StructTextConfig.dropout_rate",description:`<strong>dropout_rate</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout probabilitiy for all fully connected layers in the embeddings, encoder, and pooler.`,name:"dropout_rate"},{anchor:"transformers.Pix2StructTextConfig.layer_norm_epsilon",description:`<strong>layer_norm_epsilon</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-6) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_epsilon"},{anchor:"transformers.Pix2StructTextConfig.initializer_factor",description:`<strong>initializer_factor</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014;
A factor for initializing all weight matrices (should be kept to 1, used internally for initialization
testing).`,name:"initializer_factor"},{anchor:"transformers.Pix2StructTextConfig.dense_act_fn",description:`<strong>dense_act_fn</strong> (<code>Union[Callable, str]</code>, <em>optional</em>, defaults to <code>&quot;gelu_new&quot;</code>) &#x2014;
The non-linear activation function (function or string).`,name:"dense_act_fn"},{anchor:"transformers.Pix2StructTextConfig.decoder_start_token_id",description:`<strong>decoder_start_token_id</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The id of the <code>decoder_start_token_id</code> token.`,name:"decoder_start_token_id"},{anchor:"transformers.Pix2StructTextConfig.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the model should return the last key/values attentions (not used by all models).`,name:"use_cache"},{anchor:"transformers.Pix2StructTextConfig.pad_token_id",description:`<strong>pad_token_id</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The id of the <code>padding</code> token.`,name:"pad_token_id"},{anchor:"transformers.Pix2StructTextConfig.eos_token_id",description:`<strong>eos_token_id</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The id of the <code>end-of-sequence</code> token.`,name:"eos_token_id"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/pix2struct/configuration_pix2struct.py#L34"}}),Te=new zo({props:{anchor:"transformers.Pix2StructTextConfig.example",$$slots:{default:[xd]},$$scope:{ctx:k}}}),ct=new H({}),dt=new M({props:{name:"class transformers.Pix2StructVisionConfig",anchor:"transformers.Pix2StructVisionConfig",parameters:[{name:"hidden_size",val:" = 768"},{name:"patch_embed_hidden_size",val:" = 768"},{name:"d_ff",val:" = 2048"},{name:"d_kv",val:" = 64"},{name:"projection_dim",val:" = 768"},{name:"num_hidden_layers",val:" = 12"},{name:"num_attention_heads",val:" = 12"},{name:"num_channels",val:" = 3"},{name:"patch_size",val:" = 16"},{name:"dense_act_fn",val:" = 'gelu_new'"},{name:"layer_norm_eps",val:" = 1e-06"},{name:"dropout_rate",val:" = 0.0"},{name:"attention_dropout",val:" = 0.0"},{name:"initializer_range",val:" = 1e-10"},{name:"initializer_factor",val:" = 1.0"},{name:"seq_len",val:" = 4096"},{name:"layer_norm_bias",val:" = False"},{name:"relative_attention_num_buckets",val:" = 32"},{name:"relative_attention_max_distance",val:" = 128"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Pix2StructVisionConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
Dimensionality of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.Pix2StructVisionConfig.patch_embed_hidden_size",description:`<strong>patch_embed_hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
Dimensionality of the input patch_embedding layer in the Transformer encoder.`,name:"patch_embed_hidden_size"},{anchor:"transformers.Pix2StructVisionConfig.d_ff",description:`<strong>d_ff</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the Transformer encoder.`,name:"d_ff"},{anchor:"transformers.Pix2StructVisionConfig.d_kv",description:`<strong>d_kv</strong> (<code>int</code>, <em>optional</em>, defaults to 64) &#x2014;
Dimensionality of the key, query, value projections per attention head.`,name:"d_kv"},{anchor:"transformers.Pix2StructVisionConfig.projection_dim",description:`<strong>projection_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
Dimensionality of the projection layer in the Transformer encoder.`,name:"projection_dim"},{anchor:"transformers.Pix2StructVisionConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.Pix2StructVisionConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.Pix2StructVisionConfig.num_channels",description:`<strong>num_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
Number of channels of the input images.`,name:"num_channels"},{anchor:"transformers.Pix2StructVisionConfig.patch_size",description:`<strong>patch_size</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
The size (resolution) of each patch.`,name:"patch_size"},{anchor:"transformers.Pix2StructVisionConfig.dense_act_fn",description:`<strong>dense_act_fn</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;gelu_new&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;selu&quot;</code> and <code>&quot;gelu_new&quot;</code> \`<code>&quot;gelu&quot;</code> are supported.`,name:"dense_act_fn"},{anchor:"transformers.Pix2StructVisionConfig.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-6) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"},{anchor:"transformers.Pix2StructVisionConfig.dropout_rate",description:`<strong>dropout_rate</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout probabilitiy for all fully connected layers in the embeddings, encoder, and pooler.`,name:"dropout_rate"},{anchor:"transformers.Pix2StructVisionConfig.attention_dropout",description:`<strong>attention_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_dropout"},{anchor:"transformers.Pix2StructVisionConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-10) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.Pix2StructVisionConfig.initializer_factor",description:`<strong>initializer_factor</strong> (\`float&#x201C;, <em>optional</em>, defaults to 1) &#x2014;
A factor for initializing all weight matrices (should be kept to 1, used internally for initialization
testing).`,name:"initializer_factor"},{anchor:"transformers.Pix2StructVisionConfig.seq_len",description:`<strong>seq_len</strong> (<code>int</code>, <em>optional</em>, defaults to 4096) &#x2014;
Maximum sequence length (here number of patches) supported by the model.`,name:"seq_len"},{anchor:"transformers.Pix2StructVisionConfig.layer_norm_bias",description:`<strong>layer_norm_bias</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to add a bias to the layer normalization layers.`,name:"layer_norm_bias"},{anchor:"transformers.Pix2StructVisionConfig.relative_attention_num_buckets",description:`<strong>relative_attention_num_buckets</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014;
The number of buckets to use for each attention layer.`,name:"relative_attention_num_buckets"},{anchor:"transformers.Pix2StructVisionConfig.relative_attention_max_distance",description:`<strong>relative_attention_max_distance</strong> (<code>int</code>, <em>optional</em>, defaults to 128) &#x2014;
The maximum distance (in tokens) to use for each attention layer.`,name:"relative_attention_max_distance"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/pix2struct/configuration_pix2struct.py#L168"}}),Se=new zo({props:{anchor:"transformers.Pix2StructVisionConfig.example",$$slots:{default:[vd]},$$scope:{ctx:k}}}),ut=new H({}),pt=new M({props:{name:"class transformers.Pix2StructProcessor",anchor:"transformers.Pix2StructProcessor",parameters:[{name:"image_processor",val:""},{name:"tokenizer",val:""}],parametersDescription:[{anchor:"transformers.Pix2StructProcessor.image_processor",description:`<strong>image_processor</strong> (<code>Pix2StructImageProcessor</code>) &#x2014;
An instance of <a href="/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructImageProcessor">Pix2StructImageProcessor</a>. The image processor is a required input.`,name:"image_processor"},{anchor:"transformers.Pix2StructProcessor.tokenizer",description:"<strong>tokenizer</strong> (Union[<code>T5TokenizerFast</code>, <code>T5Tokenizer</code>]) &#x2014;\nAn instance of [&#x2018;T5TokenizerFast`] or [&#x2018;T5Tokenizer`]. The tokenizer is a required input.",name:"tokenizer"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/pix2struct/processing_pix2struct.py#L26"}}),ht=new M({props:{name:"batch_decode",anchor:"transformers.Pix2StructProcessor.batch_decode",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/pix2struct/processing_pix2struct.py#L144"}}),mt=new M({props:{name:"decode",anchor:"transformers.Pix2StructProcessor.decode",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/pix2struct/processing_pix2struct.py#L151"}}),_t=new H({}),xt=new M({props:{name:"class transformers.Pix2StructImageProcessor",anchor:"transformers.Pix2StructImageProcessor",parameters:[{name:"do_convert_rgb",val:": bool = True"},{name:"do_normalize",val:": bool = True"},{name:"patch_size",val:": typing.Dict[str, int] = None"},{name:"max_patches",val:": int = 2048"},{name:"is_vqa",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Pix2StructImageProcessor.do_convert_rgb",description:`<strong>do_convert_rgb</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to convert the image to RGB.`,name:"do_convert_rgb"},{anchor:"transformers.Pix2StructImageProcessor.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to normalize the image. Can be overridden by the <code>do_normalize</code> parameter in the <code>preprocess</code>
method. According to Pix2Struct paper and code, the image is normalized with its own mean and standard
deviation.`,name:"do_normalize"},{anchor:"transformers.Pix2StructImageProcessor.patch_size",description:`<strong>patch_size</strong> (<code>Dict[str, int]</code>, <em>optional</em>, defaults to <code>{&quot;height&quot; -- 16, &quot;width&quot;: 16}</code>):
The patch size to use for the image. According to Pix2Struct paper and code, the patch size is 16x16.`,name:"patch_size"},{anchor:"transformers.Pix2StructImageProcessor.max_patches",description:`<strong>max_patches</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
The maximum number of patches to extract from the image as per the <a href="https://arxiv.org/pdf/2210.03347.pdf" rel="nofollow">Pix2Struct
paper</a>.`,name:"max_patches"},{anchor:"transformers.Pix2StructImageProcessor.is_vqa",description:`<strong>is_vqa</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the image processor is for the VQA task. If <code>True</code> and <code>header_text</code> is passed in, text is
rendered onto the input images.`,name:"is_vqa"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/pix2struct/image_processing_pix2struct.py#L187"}}),vt=new M({props:{name:"preprocess",anchor:"transformers.Pix2StructImageProcessor.preprocess",parameters:[{name:"images",val:": typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]]"},{name:"header_text",val:": typing.Optional[str] = None"},{name:"do_convert_rgb",val:": bool = None"},{name:"do_normalize",val:": typing.Optional[bool] = None"},{name:"max_patches",val:": typing.Optional[int] = None"},{name:"patch_size",val:": typing.Union[typing.Dict[str, int], NoneType] = None"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"data_format",val:": ChannelDimension = <ChannelDimension.FIRST: 'channels_first'>"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Pix2StructImageProcessor.preprocess.images",description:`<strong>images</strong> (<code>ImageInput</code>) &#x2014;
Image to preprocess.`,name:"images"},{anchor:"transformers.Pix2StructImageProcessor.preprocess.header_text",description:`<strong>header_text</strong> (<code>Union[List[str], str]</code>, <em>optional</em>) &#x2014;
Text to render as a header. Only has an effect if <code>image_processor.is_vqa</code> is <code>True</code>.`,name:"header_text"},{anchor:"transformers.Pix2StructImageProcessor.preprocess.do_convert_rgb",description:`<strong>do_convert_rgb</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_convert_rgb</code>) &#x2014;
Whether to convert the image to RGB.`,name:"do_convert_rgb"},{anchor:"transformers.Pix2StructImageProcessor.preprocess.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_normalize</code>) &#x2014;
Whether to normalize the image.`,name:"do_normalize"},{anchor:"transformers.Pix2StructImageProcessor.preprocess.max_patches",description:`<strong>max_patches</strong> (<code>int</code>, <em>optional</em>, defaults to <code>self.max_patches</code>) &#x2014;
Maximum number of patches to extract.`,name:"max_patches"},{anchor:"transformers.Pix2StructImageProcessor.preprocess.patch_size",description:`<strong>patch_size</strong> (<code>dict</code>, <em>optional</em>, defaults to <code>self.patch_size</code>) &#x2014;
Dictionary containing the patch height and width.`,name:"patch_size"},{anchor:"transformers.Pix2StructImageProcessor.preprocess.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <code>TensorType</code>, <em>optional</em>) &#x2014;
The type of tensors to return. Can be one of:<ul>
<li>Unset: Return a list of <code>np.ndarray</code>.</li>
<li><code>TensorType.TENSORFLOW</code> or <code>&apos;tf&apos;</code>: Return a batch of type <code>tf.Tensor</code>.</li>
<li><code>TensorType.PYTORCH</code> or <code>&apos;pt&apos;</code>: Return a batch of type <code>torch.Tensor</code>.</li>
<li><code>TensorType.NUMPY</code> or <code>&apos;np&apos;</code>: Return a batch of type <code>np.ndarray</code>.</li>
<li><code>TensorType.JAX</code> or <code>&apos;jax&apos;</code>: Return a batch of type <code>jax.numpy.ndarray</code>.</li>
</ul>`,name:"return_tensors"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/pix2struct/image_processing_pix2struct.py#L323"}}),bt=new H({}),wt=new M({props:{name:"class transformers.Pix2StructTextModel",anchor:"transformers.Pix2StructTextModel",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.Pix2StructTextModel.config",description:`<strong>config</strong> (Union[<code>Pix2StructConfig</code>, <code>Pix2StructTextConfig</code>]) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/pr_22365/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/pix2struct/modeling_pix2struct.py#L1316"}}),Ct=new M({props:{name:"forward",anchor:"transformers.Pix2StructTextModel.forward",parameters:[{name:"input_ids",val:" = None"},{name:"attention_mask",val:" = None"},{name:"encoder_hidden_states",val:" = None"},{name:"encoder_attention_mask",val:" = None"},{name:"inputs_embeds",val:" = None"},{name:"head_mask",val:" = None"},{name:"cross_attn_head_mask",val:" = None"},{name:"past_key_values",val:" = None"},{name:"use_cache",val:" = None"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"labels",val:" = None"},{name:"return_dict",val:" = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Pix2StructTextModel.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Pix2StructText is a model with relative position
embeddings so you should be able to pad the inputs on both the right and the left.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_22365/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_22365/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_22365/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for detail.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a></p>
<p>To know more on how to prepare <code>input_ids</code> for pretraining take a look a <a href="./t5#training">Pix2StructText
Training</a>.`,name:"input_ids"},{anchor:"transformers.Pix2StructTextModel.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.Pix2StructTextModel.forward.decoder_input_ids",description:`<strong>decoder_input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of decoder input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_22365/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_22365/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_22365/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#decoder-input-ids">What are decoder input IDs?</a></p>
<p>Pix2StructText uses the <code>pad_token_id</code> as the starting token for <code>decoder_input_ids</code> generation. If
<code>past_key_values</code> is used, optionally only the last <code>decoder_input_ids</code> have to be input (see
<code>past_key_values</code>).</p>
<p>To know more on how to prepare <code>decoder_input_ids</code> for pretraining take a look at <a href="./t5#training">Pix2StructText
Training</a>.`,name:"decoder_input_ids"},{anchor:"transformers.Pix2StructTextModel.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.BoolTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Default behavior: generate a tensor that ignores pad tokens in <code>decoder_input_ids</code>. Causal mask will also
be used by default.`,name:"decoder_attention_mask"},{anchor:"transformers.Pix2StructTextModel.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules in the encoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.Pix2StructTextModel.forward.decoder_head_mask",description:`<strong>decoder_head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules in the decoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"decoder_head_mask"},{anchor:"transformers.Pix2StructTextModel.forward.cross_attn_head_mask",description:`<strong>cross_attn_head_mask</strong> (<code>torch.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the cross-attention modules in the decoder. Mask values selected in
<code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"cross_attn_head_mask"},{anchor:"transformers.Pix2StructTextModel.forward.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <code>optional</code>: <em>hidden_states</em>, <code>optional</code>: <em>attentions</em>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code> is a sequence of hidden states at
the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.Pix2StructTextModel.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code> of length <code>config.n_layers</code> with each tuple having 4 tensors of shape <code>(batch_size, num_heads, sequence_length - 1, embed_size_per_head)</code>) &#x2014;
Contains precomputed key and value hidden states of the attention layers. Can be used to speed up decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.Pix2StructTextModel.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.Pix2StructTextModel.forward.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, target_sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>decoder_input_ids</code> you can choose to directly pass an embedded
representation. If <code>past_key_values</code> is used, optionally only the last <code>decoder_inputs_embeds</code> have to be
input (see <code>past_key_values</code>). This is useful if you want more control over how to convert
<code>decoder_input_ids</code> indices into associated vectors than the model&#x2019;s internal embedding lookup matrix.</p>
<p>If <code>decoder_input_ids</code> and <code>decoder_inputs_embeds</code> are both unset, <code>decoder_inputs_embeds</code> takes the value
of <code>inputs_embeds</code>.`,name:"decoder_inputs_embeds"},{anchor:"transformers.Pix2StructTextModel.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.Pix2StructTextModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Pix2StructTextModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Pix2StructTextModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22365/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/pix2struct/modeling_pix2struct.py#L1372",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22365/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithCrossAttentions"
>transformers.modeling_outputs.CausalLMOutputWithCrossAttentions</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructConfig"
>Pix2StructConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Language modeling loss (for next-token prediction).</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Cross attentions weights after the attention softmax, used to compute the weighted average in the
cross-attention heads.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> tuples of length <code>config.n_layers</code>, with each tuple containing the cached key,
value states of the self-attention and the cross-attention layers if model is used in encoder-decoder
setting. Only relevant if <code>config.is_decoder = True</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22365/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithCrossAttentions"
>transformers.modeling_outputs.CausalLMOutputWithCrossAttentions</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),qe=new ji({props:{$$slots:{default:[Pd]},$$scope:{ctx:k}}}),Ie=new zo({props:{anchor:"transformers.Pix2StructTextModel.forward.example",$$slots:{default:[bd]},$$scope:{ctx:k}}}),zt=new H({}),Et=new M({props:{name:"class transformers.Pix2StructVisionModel",anchor:"transformers.Pix2StructVisionModel",parameters:[{name:"config",val:": Pix2StructConfig"}],parametersDescription:[{anchor:"transformers.Pix2StructVisionModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructConfig">Pix2StructConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22365/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/pix2struct/modeling_pix2struct.py#L547"}}),It=new M({props:{name:"forward",anchor:"transformers.Pix2StructVisionModel.forward",parameters:[{name:"flattened_patches",val:": typing.Optional[torch.Tensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.Pix2StructVisionModel.forward.flattened_patches",description:`<strong>flattened_patches</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, num_channels x patch_height x patch_width)</code>) &#x2014;
Flattened and padded pixel values. These values can be obtained using <a href="/docs/transformers/pr_22365/en/model_doc/auto#transformers.AutoImageProcessor">AutoImageProcessor</a>. See
<code>Pix2StructVisionImageProcessor.__call__</code> for details. Check the <a href="https://arxiv.org/abs/2210.03347" rel="nofollow">original
paper</a> (figure 5) for more details.`,name:"flattened_patches"},{anchor:"transformers.Pix2StructVisionModel.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding pixel values. Mask values selected in <code>[0, 1]</code>:`,name:"attention_mask"},{anchor:"transformers.Pix2StructVisionModel.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.Pix2StructVisionModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Pix2StructVisionModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Pix2StructVisionModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22365/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/pix2struct/modeling_pix2struct.py#L580",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22365/en/main_classes/output#transformers.modeling_outputs.BaseModelOutputWithPooling"
>transformers.modeling_outputs.BaseModelOutputWithPooling</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructConfig"
>Pix2StructConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>pooler_output</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, hidden_size)</code>) \u2014 Last layer hidden-state of the first token of the sequence (classification token) after further processing
through the layers used for the auxiliary pretraining task. E.g. for BERT-family of models, this returns
the classification token after processing through a linear layer and a tanh activation function. The linear
layer weights are trained from the next sentence prediction (classification) objective during pretraining.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22365/en/main_classes/output#transformers.modeling_outputs.BaseModelOutputWithPooling"
>transformers.modeling_outputs.BaseModelOutputWithPooling</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),je=new ji({props:{$$slots:{default:[wd]},$$scope:{ctx:k}}}),Ae=new zo({props:{anchor:"transformers.Pix2StructVisionModel.forward.example",$$slots:{default:[Td]},$$scope:{ctx:k}}}),Ft=new H({}),jt=new M({props:{name:"class transformers.Pix2StructForConditionalGeneration",anchor:"transformers.Pix2StructForConditionalGeneration",parameters:[{name:"config",val:": Pix2StructConfig"}],parametersDescription:[{anchor:"transformers.Pix2StructForConditionalGeneration.config",description:`<strong>config</strong> (Union[<code>Pix2StructConfig</code>, <code>Pix2StructTextConfig</code>]) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/pr_22365/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/pix2struct/modeling_pix2struct.py#L1601"}}),Lt=new M({props:{name:"forward",anchor:"transformers.Pix2StructForConditionalGeneration.forward",parameters:[{name:"flattened_patches",val:": typing.Optional[torch.FloatTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"decoder_input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"decoder_attention_mask",val:": typing.Optional[torch.BoolTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"decoder_head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"cross_attn_head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"encoder_outputs",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"decoder_inputs_embeds",val:": typing.Optional[torch.Tensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.Pix2StructForConditionalGeneration.forward.flattened_patches",description:`<strong>flattened_patches</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, seq_length, hidden_size)</code>) &#x2014;
Flattened pixel patches. the <code>hidden_size</code> is obtained by the following formula: <code>hidden_size</code> =
<code>num_channels</code> <em> <code>patch_size</code> </em> <code>patch_size</code></p>
<p>The process of flattening the pixel patches is done by <code>Pix2StructProcessor</code>.`,name:"flattened_patches"},{anchor:"transformers.Pix2StructForConditionalGeneration.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.Pix2StructForConditionalGeneration.forward.decoder_input_ids",description:`<strong>decoder_input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of decoder input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_22365/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_22365/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_22365/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#decoder-input-ids">What are decoder input IDs?</a></p>
<p>Pix2StructText uses the <code>pad_token_id</code> as the starting token for <code>decoder_input_ids</code> generation. If
<code>past_key_values</code> is used, optionally only the last <code>decoder_input_ids</code> have to be input (see
<code>past_key_values</code>).</p>
<p>To know more on how to prepare <code>decoder_input_ids</code> for pretraining take a look at <a href="./t5#training">Pix2StructText
Training</a>.`,name:"decoder_input_ids"},{anchor:"transformers.Pix2StructForConditionalGeneration.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.BoolTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Default behavior: generate a tensor that ignores pad tokens in <code>decoder_input_ids</code>. Causal mask will also
be used by default.`,name:"decoder_attention_mask"},{anchor:"transformers.Pix2StructForConditionalGeneration.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules in the encoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.Pix2StructForConditionalGeneration.forward.decoder_head_mask",description:`<strong>decoder_head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules in the decoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"decoder_head_mask"},{anchor:"transformers.Pix2StructForConditionalGeneration.forward.cross_attn_head_mask",description:`<strong>cross_attn_head_mask</strong> (<code>torch.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the cross-attention modules in the decoder. Mask values selected in
<code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"cross_attn_head_mask"},{anchor:"transformers.Pix2StructForConditionalGeneration.forward.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <code>optional</code>: <em>hidden_states</em>, <code>optional</code>: <em>attentions</em>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code> is a sequence of hidden states at
the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.Pix2StructForConditionalGeneration.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code> of length <code>config.n_layers</code> with each tuple having 4 tensors of shape <code>(batch_size, num_heads, sequence_length - 1, embed_size_per_head)</code>) &#x2014;
Contains precomputed key and value hidden states of the attention layers. Can be used to speed up decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.Pix2StructForConditionalGeneration.forward.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, target_sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>decoder_input_ids</code> you can choose to directly pass an embedded
representation. If <code>past_key_values</code> is used, optionally only the last <code>decoder_inputs_embeds</code> have to be
input (see <code>past_key_values</code>). This is useful if you want more control over how to convert
<code>decoder_input_ids</code> indices into associated vectors than the model&#x2019;s internal embedding lookup matrix.</p>
<p>If <code>decoder_input_ids</code> and <code>decoder_inputs_embeds</code> are both unset, <code>decoder_inputs_embeds</code> takes the value
of <code>inputs_embeds</code>.`,name:"decoder_inputs_embeds"},{anchor:"transformers.Pix2StructForConditionalGeneration.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for computing the masked language modeling loss for the decoder.`,name:"labels"},{anchor:"transformers.Pix2StructForConditionalGeneration.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.Pix2StructForConditionalGeneration.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Pix2StructForConditionalGeneration.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Pix2StructForConditionalGeneration.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22365/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_22365/src/transformers/models/pix2struct/modeling_pix2struct.py#L1641",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22365/en/main_classes/output#transformers.modeling_outputs.Seq2SeqModelOutput"
>transformers.modeling_outputs.Seq2SeqModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructConfig"
>Pix2StructConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the decoder of the model.</p>
<p>If <code>past_key_values</code> is used only the last hidden-state of the sequences of shape <code>(batch_size, 1, hidden_size)</code> is output.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and 2 additional tensors of shape
<code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and in the cross-attention
blocks) that can be used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the decoder at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax, used to compute the
weighted average in the cross-attention heads.</p>
</li>
<li>
<p><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</p>
</li>
<li>
<p><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the encoder at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the encoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22365/en/main_classes/output#transformers.modeling_outputs.Seq2SeqModelOutput"
>transformers.modeling_outputs.Seq2SeqModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Ne=new ji({props:{$$slots:{default:[yd]},$$scope:{ctx:k}}}),De=new zo({props:{anchor:"transformers.Pix2StructForConditionalGeneration.forward.example",$$slots:{default:[Sd]},$$scope:{ctx:k}}}),{c(){p=n("meta"),S=l(),_=n("h1"),f=n("a"),x=n("span"),v(c.$$.fragment),g=l(),q=n("span"),_r=a("Pix2Struct"),wn=l(),Z=n("h2"),ge=n("a"),qo=n("span"),v(He.$$.fragment),xr=l(),Io=n("span"),vr=a("Overview"),Tn=l(),_e=n("p"),Pr=a("The Pix2Struct model was proposed in "),Be=n("a"),br=a("Pix2Struct: Screenshot Parsing as Pretraining for Visual Language Understanding"),wr=a(" by Kenton Lee, Mandar Joshi, Iulia Turc, Hexiang Hu, Fangyu Liu, Julian Eisenschlos, Urvashi Khandelwal, Peter Shaw, Ming-Wei Chang, Kristina Toutanova."),yn=l(),Ht=n("p"),Tr=a("The abstract from the paper is the following:"),Sn=l(),Bt=n("blockquote"),Fo=n("p"),yr=a("Visually-situated language is ubiquitous \u2014 sources range from textbooks with diagrams to web pages with images and tables, to mobile apps with buttons and forms. Perhaps due to this diversity, previous work has typically relied on domain-specific recipes with limited sharing of the underlying data, model architectures, and objectives. We present Pix2Struct, a pretrained image-to-text model for purely visual language understanding, which can be finetuned on tasks containing visually-situated language. Pix2Struct is pretrained by learning to parse masked screenshots of web pages into simplified HTML. The web, with its richness of visual elements cleanly reflected in the HTML structure, provides a large source of pretraining data well suited to the diversity of downstream tasks. Intuitively, this objective subsumes common pretraining signals such as OCR, language modeling, image captioning. In addition to the novel pretraining strategy, we introduce a variable-resolution input representation and a more flexible integration of language and vision inputs, where language prompts such as questions are rendered directly on top of the input image. For the first time, we show that a single pretrained model can achieve state-of-the-art results in six out of nine tasks across four domains: documents, illustrations, user interfaces, and natural images."),kn=l(),Kt=n("p"),Sr=a("Tips:"),$n=l(),Xt=n("p"),kr=a(`Pix2Struct has been fine tuned on a variety of tasks and datasets, ranging from image captioning, visual question answering (VQA) over different inputs (books, charts, science diagrams), captioning UI components etc. The full list can be found in Table 1 of the paper.
We therefore advise you to use these models for the tasks they have been fine tuned on. For instance, if you want to use Pix2Struct for UI captioning, you should use the model fine tuned on the UI dataset. If you want to use Pix2Struct for image captioning, you should use the model fine tuned on the natural images captioning dataset and so on.`),Cn=l(),B=n("p"),$r=a("This model was contributed by "),Ke=n("a"),Cr=a("ybelkada"),zr=a(`.
The original code can be found `),Xe=n("a"),Er=a("here"),Mr=a("."),zn=l(),ee=n("h2"),xe=n("a"),jo=n("span"),v(Je.$$.fragment),qr=l(),Ao=n("span"),Ir=a("Resources:"),En=l(),K=n("ul"),Vo=n("li"),Qe=n("a"),Fr=a("Paper"),jr=l(),No=n("li"),Ye=n("a"),Ar=a("Fine-tuning Notebook"),Vr=l(),Do=n("li"),Ze=n("a"),Nr=a("All models"),Mn=l(),te=n("h2"),ve=n("a"),Oo=n("span"),v(et.$$.fragment),Dr=l(),Lo=n("span"),Or=a("Pix2StructConfig"),qn=l(),z=n("div"),v(tt.$$.fragment),Lr=l(),X=n("p"),Jt=n("a"),Ur=a("Pix2StructConfig"),Rr=a(" is the configuration class to store the configuration of a "),Uo=n("code"),Wr=a("Pix2StructModel"),Gr=a(`. It is used to
instantiate a PIX2STRUCT model according to the specified arguments, defining the text model and vision model
configs. Instantiating a configuration with the defaults will yield a similar configuration to that of the
PIX2STRUCT-base `),ot=n("a"),Hr=a("Salesforce/pix2struct-vqa-base"),Br=a(`
architecture.`),Kr=l(),oe=n("p"),Xr=a("Configuration objects inherit from "),Qt=n("a"),Jr=a("PretrainedConfig"),Qr=a(` and can be used to control the model outputs. Read the
documentation from `),Yt=n("a"),Yr=a("PretrainedConfig"),Zr=a(" for more information."),es=l(),v(Pe.$$.fragment),ts=l(),be=n("div"),v(nt.$$.fragment),os=l(),rt=n("p"),ns=a("Instantiate a "),Zt=n("a"),rs=a("Pix2StructConfig"),ss=a(` (or a derived class) from pix2struct text model configuration and pix2struct
vision model configuration.`),In=l(),ne=n("h2"),we=n("a"),Ro=n("span"),v(st.$$.fragment),as=l(),Wo=n("span"),is=a("Pix2StructTextConfig"),Fn=l(),F=n("div"),v(at.$$.fragment),cs=l(),U=n("p"),ds=a("This is the configuration class to store the configuration of a "),eo=n("a"),ls=a("Pix2StructTextModel"),us=a(`. It is used to instantiate
a Pix2Struct text model according to the specified arguments, defining the model architecture. Instantiating a
configuration with the defaults will yield a similar configuration to that of the `),Go=n("code"),ps=a("Pix2StructText"),hs=a(` used by the
`),it=n("a"),fs=a("base architectures"),ms=a("."),gs=l(),re=n("p"),_s=a("Configuration objects inherit from "),to=n("a"),xs=a("PretrainedConfig"),vs=a(` and can be used to control the model outputs. Read the
documentation from `),oo=n("a"),Ps=a("PretrainedConfig"),bs=a(" for more information."),ws=l(),v(Te.$$.fragment),jn=l(),se=n("h2"),ye=n("a"),Ho=n("span"),v(ct.$$.fragment),Ts=l(),Bo=n("span"),ys=a("Pix2StructVisionConfig"),An=l(),j=n("div"),v(dt.$$.fragment),Ss=l(),ae=n("p"),ks=a("This is the configuration class to store the configuration of a "),no=n("a"),$s=a("Pix2StructVisionModel"),Cs=a(`. It is used to
instantiate a PIX2STRUCT vision model according to the specified arguments, defining the model architecture.
Instantiating a configuration defaults will yield a similar configuration to that of the Pix2Struct-base
`),lt=n("a"),zs=a("Salesforce/pix2struct-vqa-base"),Es=a(" architecture."),Ms=l(),ie=n("p"),qs=a("Configuration objects inherit from "),ro=n("a"),Is=a("PretrainedConfig"),Fs=a(` and can be used to control the model outputs. Read the
documentation from `),so=n("a"),js=a("PretrainedConfig"),As=a(" for more information."),Vs=l(),v(Se.$$.fragment),Vn=l(),ce=n("h2"),ke=n("a"),Ko=n("span"),v(ut.$$.fragment),Ns=l(),Xo=n("span"),Ds=a("Pix2StructProcessor"),Nn=l(),E=n("div"),v(pt.$$.fragment),Os=l(),Jo=n("p"),Ls=a(`Constructs a PIX2STRUCT processor which wraps a BERT tokenizer and PIX2STRUCT image processor into a single
processor.`),Us=l(),I=n("p"),ao=n("a"),Rs=a("Pix2StructProcessor"),Ws=a(" offers all the functionalities of "),io=n("a"),Gs=a("Pix2StructImageProcessor"),Hs=a(" and "),co=n("a"),Bs=a("T5TokenizerFast"),Ks=a(`. See
the docstring of `),Qo=n("code"),Xs=a("__call__()"),Js=a(" and "),lo=n("a"),Qs=a("decode()"),Ys=a(" for more information."),Zs=l(),$e=n("div"),v(ht.$$.fragment),ea=l(),ft=n("p"),ta=a("This method forwards all its arguments to Pix2StructTokenizerFast\u2019s "),uo=n("a"),oa=a("batch_decode()"),na=a(`.
Please refer to the docstring of this method for more information.`),ra=l(),Ce=n("div"),v(mt.$$.fragment),sa=l(),gt=n("p"),aa=a("This method forwards all its arguments to Pix2StructTokenizerFast\u2019s "),po=n("a"),ia=a("decode()"),ca=a(`. Please
refer to the docstring of this method for more information.`),Dn=l(),de=n("h2"),ze=n("a"),Yo=n("span"),v(_t.$$.fragment),da=l(),Zo=n("span"),la=a("Pix2StructImageProcessor"),On=l(),R=n("div"),v(xt.$$.fragment),ua=l(),en=n("p"),pa=a("Constructs a Pix2Struct image processor."),ha=l(),Ee=n("div"),v(vt.$$.fragment),fa=l(),A=n("p"),ma=a(`Preprocess an image or batch of images. The processor first computes the maximum possible number of
aspect-ratio preserving patches of size `),tn=n("code"),ga=a("patch_size"),_a=a(` that can be extracted from the image. It then pads the
image with zeros to make the image respect the constraint of `),on=n("code"),xa=a("max_patches"),va=a(`. Before extracting the patches the
images are standardized following the tensorflow implementation of `),nn=n("code"),Pa=a("per_image_standardization"),ba=a(`
(`),Pt=n("a"),wa=a("https://www.tensorflow.org/api_docs/python/tf/image/per_image_standardization"),Ta=a(")."),Ln=l(),le=n("h2"),Me=n("a"),rn=n("span"),v(bt.$$.fragment),ya=l(),sn=n("span"),Sa=a("Pix2StructTextModel"),Un=l(),$=n("div"),v(wt.$$.fragment),ka=l(),an=n("p"),$a=a("The standalone text decoder of Pix2Struct"),Ca=l(),Tt=n("p"),za=a("The Pix2Struct model was proposed in "),yt=n("a"),Ea=a(`Pix2Struct: Screenshot Parsing as Pretraining for Visual Language
Understanding`),Ma=a(` by Kenton Lee, Mandar Joshi, Iulia Turc, Hexiang Hu, Fangyu Liu,
Julian Eisenschlos, Urvashi Khandelwal, Peter Shaw, Ming-Wei Chang, Kristina Toutanova. It\u2019s an encoder decoder
transformer pre-trained in a image-to-text setting.`),qa=l(),St=n("p"),Ia=a("This model inherits from "),ho=n("a"),Fa=a("PreTrainedModel"),ja=a(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Aa=l(),kt=n("p"),Va=a("This model is also a PyTorch "),$t=n("a"),Na=a("torch.nn.Module"),Da=a(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Oa=l(),V=n("div"),v(Ct.$$.fragment),La=l(),ue=n("p"),Ua=a("The "),fo=n("a"),Ra=a("Pix2StructTextModel"),Wa=a(" forward method, overrides the "),cn=n("code"),Ga=a("__call__"),Ha=a(" special method."),Ba=l(),v(qe.$$.fragment),Ka=l(),v(Ie.$$.fragment),Rn=l(),pe=n("h2"),Fe=n("a"),dn=n("span"),v(zt.$$.fragment),Xa=l(),ln=n("span"),Ja=a("Pix2StructVisionModel"),Wn=l(),W=n("div"),v(Et.$$.fragment),Qa=l(),Mt=n("p"),Ya=a(`The bare Pix2StructVision Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),qt=n("a"),Za=a("torch.nn.Module"),ei=a(` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),ti=l(),N=n("div"),v(It.$$.fragment),oi=l(),he=n("p"),ni=a("The "),mo=n("a"),ri=a("Pix2StructVisionModel"),si=a(" forward method, overrides the "),un=n("code"),ai=a("__call__"),ii=a(" special method."),ci=l(),v(je.$$.fragment),di=l(),v(Ae.$$.fragment),Gn=l(),fe=n("h2"),Ve=n("a"),pn=n("span"),v(Ft.$$.fragment),li=l(),hn=n("span"),ui=a("Pix2StructForConditionalGeneration"),Hn=l(),C=n("div"),v(jt.$$.fragment),pi=l(),fn=n("p"),hi=a("A conditional generation model with a language modeling head. Can be used for sequence generation tasks."),fi=l(),At=n("p"),mi=a("The Pix2Struct model was proposed in "),Vt=n("a"),gi=a(`Pix2Struct: Screenshot Parsing as Pretraining for Visual Language
Understanding`),_i=a(` by Kenton Lee, Mandar Joshi, Iulia Turc, Hexiang Hu, Fangyu Liu,
Julian Eisenschlos, Urvashi Khandelwal, Peter Shaw, Ming-Wei Chang, Kristina Toutanova. It\u2019s an encoder decoder
transformer pre-trained in a image-to-text setting.`),xi=l(),Nt=n("p"),vi=a("This model inherits from "),go=n("a"),Pi=a("PreTrainedModel"),bi=a(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),wi=l(),Dt=n("p"),Ti=a("This model is also a PyTorch "),Ot=n("a"),yi=a("torch.nn.Module"),Si=a(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),ki=l(),D=n("div"),v(Lt.$$.fragment),$i=l(),me=n("p"),Ci=a("The "),_o=n("a"),zi=a("Pix2StructForConditionalGeneration"),Ei=a(" forward method, overrides the "),mn=n("code"),Mi=a("__call__"),qi=a(" special method."),Ii=l(),v(Ne.$$.fragment),Fi=l(),v(De.$$.fragment),this.h()},l(t){const h=md('[data-svelte="svelte-1phssyn"]',document.head);p=r(h,"META",{name:!0,content:!0}),h.forEach(o),S=u(t),_=r(t,"H1",{class:!0});var Ut=s(_);f=r(Ut,"A",{id:!0,class:!0,href:!0});var gn=s(f);x=r(gn,"SPAN",{});var _n=s(x);P(c.$$.fragment,_n),_n.forEach(o),gn.forEach(o),g=u(Ut),q=r(Ut,"SPAN",{});var xn=s(q);_r=i(xn,"Pix2Struct"),xn.forEach(o),Ut.forEach(o),wn=u(t),Z=r(t,"H2",{class:!0});var Rt=s(Z);ge=r(Rt,"A",{id:!0,class:!0,href:!0});var vn=s(ge);qo=r(vn,"SPAN",{});var Pn=s(qo);P(He.$$.fragment,Pn),Pn.forEach(o),vn.forEach(o),xr=u(Rt),Io=r(Rt,"SPAN",{});var bn=s(Io);vr=i(bn,"Overview"),bn.forEach(o),Rt.forEach(o),Tn=u(t),_e=r(t,"P",{});var Wt=s(_e);Pr=i(Wt,"The Pix2Struct model was proposed in "),Be=r(Wt,"A",{href:!0,rel:!0});var Ai=s(Be);br=i(Ai,"Pix2Struct: Screenshot Parsing as Pretraining for Visual Language Understanding"),Ai.forEach(o),wr=i(Wt," by Kenton Lee, Mandar Joshi, Iulia Turc, Hexiang Hu, Fangyu Liu, Julian Eisenschlos, Urvashi Khandelwal, Peter Shaw, Ming-Wei Chang, Kristina Toutanova."),Wt.forEach(o),yn=u(t),Ht=r(t,"P",{});var Vi=s(Ht);Tr=i(Vi,"The abstract from the paper is the following:"),Vi.forEach(o),Sn=u(t),Bt=r(t,"BLOCKQUOTE",{});var Ni=s(Bt);Fo=r(Ni,"P",{});var Di=s(Fo);yr=i(Di,"Visually-situated language is ubiquitous \u2014 sources range from textbooks with diagrams to web pages with images and tables, to mobile apps with buttons and forms. Perhaps due to this diversity, previous work has typically relied on domain-specific recipes with limited sharing of the underlying data, model architectures, and objectives. We present Pix2Struct, a pretrained image-to-text model for purely visual language understanding, which can be finetuned on tasks containing visually-situated language. Pix2Struct is pretrained by learning to parse masked screenshots of web pages into simplified HTML. The web, with its richness of visual elements cleanly reflected in the HTML structure, provides a large source of pretraining data well suited to the diversity of downstream tasks. Intuitively, this objective subsumes common pretraining signals such as OCR, language modeling, image captioning. In addition to the novel pretraining strategy, we introduce a variable-resolution input representation and a more flexible integration of language and vision inputs, where language prompts such as questions are rendered directly on top of the input image. For the first time, we show that a single pretrained model can achieve state-of-the-art results in six out of nine tasks across four domains: documents, illustrations, user interfaces, and natural images."),Di.forEach(o),Ni.forEach(o),kn=u(t),Kt=r(t,"P",{});var Oi=s(Kt);Sr=i(Oi,"Tips:"),Oi.forEach(o),$n=u(t),Xt=r(t,"P",{});var Li=s(Xt);kr=i(Li,`Pix2Struct has been fine tuned on a variety of tasks and datasets, ranging from image captioning, visual question answering (VQA) over different inputs (books, charts, science diagrams), captioning UI components etc. The full list can be found in Table 1 of the paper.
We therefore advise you to use these models for the tasks they have been fine tuned on. For instance, if you want to use Pix2Struct for UI captioning, you should use the model fine tuned on the UI dataset. If you want to use Pix2Struct for image captioning, you should use the model fine tuned on the natural images captioning dataset and so on.`),Li.forEach(o),Cn=u(t),B=r(t,"P",{});var xo=s(B);$r=i(xo,"This model was contributed by "),Ke=r(xo,"A",{href:!0,rel:!0});var Ui=s(Ke);Cr=i(Ui,"ybelkada"),Ui.forEach(o),zr=i(xo,`.
The original code can be found `),Xe=r(xo,"A",{href:!0,rel:!0});var Ri=s(Xe);Er=i(Ri,"here"),Ri.forEach(o),Mr=i(xo,"."),xo.forEach(o),zn=u(t),ee=r(t,"H2",{class:!0});var Kn=s(ee);xe=r(Kn,"A",{id:!0,class:!0,href:!0});var Wi=s(xe);jo=r(Wi,"SPAN",{});var Gi=s(jo);P(Je.$$.fragment,Gi),Gi.forEach(o),Wi.forEach(o),qr=u(Kn),Ao=r(Kn,"SPAN",{});var Hi=s(Ao);Ir=i(Hi,"Resources:"),Hi.forEach(o),Kn.forEach(o),En=u(t),K=r(t,"UL",{});var vo=s(K);Vo=r(vo,"LI",{});var Bi=s(Vo);Qe=r(Bi,"A",{href:!0,rel:!0});var Ki=s(Qe);Fr=i(Ki,"Paper"),Ki.forEach(o),Bi.forEach(o),jr=u(vo),No=r(vo,"LI",{});var Xi=s(No);Ye=r(Xi,"A",{href:!0,rel:!0});var Ji=s(Ye);Ar=i(Ji,"Fine-tuning Notebook"),Ji.forEach(o),Xi.forEach(o),Vr=u(vo),Do=r(vo,"LI",{});var Qi=s(Do);Ze=r(Qi,"A",{href:!0,rel:!0});var Yi=s(Ze);Nr=i(Yi,"All models"),Yi.forEach(o),Qi.forEach(o),vo.forEach(o),Mn=u(t),te=r(t,"H2",{class:!0});var Xn=s(te);ve=r(Xn,"A",{id:!0,class:!0,href:!0});var Zi=s(ve);Oo=r(Zi,"SPAN",{});var ec=s(Oo);P(et.$$.fragment,ec),ec.forEach(o),Zi.forEach(o),Dr=u(Xn),Lo=r(Xn,"SPAN",{});var tc=s(Lo);Or=i(tc,"Pix2StructConfig"),tc.forEach(o),Xn.forEach(o),qn=u(t),z=r(t,"DIV",{class:!0});var J=s(z);P(tt.$$.fragment,J),Lr=u(J),X=r(J,"P",{});var Gt=s(X);Jt=r(Gt,"A",{href:!0});var oc=s(Jt);Ur=i(oc,"Pix2StructConfig"),oc.forEach(o),Rr=i(Gt," is the configuration class to store the configuration of a "),Uo=r(Gt,"CODE",{});var nc=s(Uo);Wr=i(nc,"Pix2StructModel"),nc.forEach(o),Gr=i(Gt,`. It is used to
instantiate a PIX2STRUCT model according to the specified arguments, defining the text model and vision model
configs. Instantiating a configuration with the defaults will yield a similar configuration to that of the
PIX2STRUCT-base `),ot=r(Gt,"A",{href:!0,rel:!0});var rc=s(ot);Hr=i(rc,"Salesforce/pix2struct-vqa-base"),rc.forEach(o),Br=i(Gt,`
architecture.`),Gt.forEach(o),Kr=u(J),oe=r(J,"P",{});var Po=s(oe);Xr=i(Po,"Configuration objects inherit from "),Qt=r(Po,"A",{href:!0});var sc=s(Qt);Jr=i(sc,"PretrainedConfig"),sc.forEach(o),Qr=i(Po,` and can be used to control the model outputs. Read the
documentation from `),Yt=r(Po,"A",{href:!0});var ac=s(Yt);Yr=i(ac,"PretrainedConfig"),ac.forEach(o),Zr=i(Po," for more information."),Po.forEach(o),es=u(J),P(Pe.$$.fragment,J),ts=u(J),be=r(J,"DIV",{class:!0});var Jn=s(be);P(nt.$$.fragment,Jn),os=u(Jn),rt=r(Jn,"P",{});var Qn=s(rt);ns=i(Qn,"Instantiate a "),Zt=r(Qn,"A",{href:!0});var ic=s(Zt);rs=i(ic,"Pix2StructConfig"),ic.forEach(o),ss=i(Qn,` (or a derived class) from pix2struct text model configuration and pix2struct
vision model configuration.`),Qn.forEach(o),Jn.forEach(o),J.forEach(o),In=u(t),ne=r(t,"H2",{class:!0});var Yn=s(ne);we=r(Yn,"A",{id:!0,class:!0,href:!0});var cc=s(we);Ro=r(cc,"SPAN",{});var dc=s(Ro);P(st.$$.fragment,dc),dc.forEach(o),cc.forEach(o),as=u(Yn),Wo=r(Yn,"SPAN",{});var lc=s(Wo);is=i(lc,"Pix2StructTextConfig"),lc.forEach(o),Yn.forEach(o),Fn=u(t),F=r(t,"DIV",{class:!0});var Oe=s(F);P(at.$$.fragment,Oe),cs=u(Oe),U=r(Oe,"P",{});var Le=s(U);ds=i(Le,"This is the configuration class to store the configuration of a "),eo=r(Le,"A",{href:!0});var uc=s(eo);ls=i(uc,"Pix2StructTextModel"),uc.forEach(o),us=i(Le,`. It is used to instantiate
a Pix2Struct text model according to the specified arguments, defining the model architecture. Instantiating a
configuration with the defaults will yield a similar configuration to that of the `),Go=r(Le,"CODE",{});var pc=s(Go);ps=i(pc,"Pix2StructText"),pc.forEach(o),hs=i(Le,` used by the
`),it=r(Le,"A",{href:!0,rel:!0});var hc=s(it);fs=i(hc,"base architectures"),hc.forEach(o),ms=i(Le,"."),Le.forEach(o),gs=u(Oe),re=r(Oe,"P",{});var bo=s(re);_s=i(bo,"Configuration objects inherit from "),to=r(bo,"A",{href:!0});var fc=s(to);xs=i(fc,"PretrainedConfig"),fc.forEach(o),vs=i(bo,` and can be used to control the model outputs. Read the
documentation from `),oo=r(bo,"A",{href:!0});var mc=s(oo);Ps=i(mc,"PretrainedConfig"),mc.forEach(o),bs=i(bo," for more information."),bo.forEach(o),ws=u(Oe),P(Te.$$.fragment,Oe),Oe.forEach(o),jn=u(t),se=r(t,"H2",{class:!0});var Zn=s(se);ye=r(Zn,"A",{id:!0,class:!0,href:!0});var gc=s(ye);Ho=r(gc,"SPAN",{});var _c=s(Ho);P(ct.$$.fragment,_c),_c.forEach(o),gc.forEach(o),Ts=u(Zn),Bo=r(Zn,"SPAN",{});var xc=s(Bo);ys=i(xc,"Pix2StructVisionConfig"),xc.forEach(o),Zn.forEach(o),An=u(t),j=r(t,"DIV",{class:!0});var Ue=s(j);P(dt.$$.fragment,Ue),Ss=u(Ue),ae=r(Ue,"P",{});var wo=s(ae);ks=i(wo,"This is the configuration class to store the configuration of a "),no=r(wo,"A",{href:!0});var vc=s(no);$s=i(vc,"Pix2StructVisionModel"),vc.forEach(o),Cs=i(wo,`. It is used to
instantiate a PIX2STRUCT vision model according to the specified arguments, defining the model architecture.
Instantiating a configuration defaults will yield a similar configuration to that of the Pix2Struct-base
`),lt=r(wo,"A",{href:!0,rel:!0});var Pc=s(lt);zs=i(Pc,"Salesforce/pix2struct-vqa-base"),Pc.forEach(o),Es=i(wo," architecture."),wo.forEach(o),Ms=u(Ue),ie=r(Ue,"P",{});var To=s(ie);qs=i(To,"Configuration objects inherit from "),ro=r(To,"A",{href:!0});var bc=s(ro);Is=i(bc,"PretrainedConfig"),bc.forEach(o),Fs=i(To,` and can be used to control the model outputs. Read the
documentation from `),so=r(To,"A",{href:!0});var wc=s(so);js=i(wc,"PretrainedConfig"),wc.forEach(o),As=i(To," for more information."),To.forEach(o),Vs=u(Ue),P(Se.$$.fragment,Ue),Ue.forEach(o),Vn=u(t),ce=r(t,"H2",{class:!0});var er=s(ce);ke=r(er,"A",{id:!0,class:!0,href:!0});var Tc=s(ke);Ko=r(Tc,"SPAN",{});var yc=s(Ko);P(ut.$$.fragment,yc),yc.forEach(o),Tc.forEach(o),Ns=u(er),Xo=r(er,"SPAN",{});var Sc=s(Xo);Ds=i(Sc,"Pix2StructProcessor"),Sc.forEach(o),er.forEach(o),Nn=u(t),E=r(t,"DIV",{class:!0});var Q=s(E);P(pt.$$.fragment,Q),Os=u(Q),Jo=r(Q,"P",{});var kc=s(Jo);Ls=i(kc,`Constructs a PIX2STRUCT processor which wraps a BERT tokenizer and PIX2STRUCT image processor into a single
processor.`),kc.forEach(o),Us=u(Q),I=r(Q,"P",{});var G=s(I);ao=r(G,"A",{href:!0});var $c=s(ao);Rs=i($c,"Pix2StructProcessor"),$c.forEach(o),Ws=i(G," offers all the functionalities of "),io=r(G,"A",{href:!0});var Cc=s(io);Gs=i(Cc,"Pix2StructImageProcessor"),Cc.forEach(o),Hs=i(G," and "),co=r(G,"A",{href:!0});var zc=s(co);Bs=i(zc,"T5TokenizerFast"),zc.forEach(o),Ks=i(G,`. See
the docstring of `),Qo=r(G,"CODE",{});var Ec=s(Qo);Xs=i(Ec,"__call__()"),Ec.forEach(o),Js=i(G," and "),lo=r(G,"A",{href:!0});var Mc=s(lo);Qs=i(Mc,"decode()"),Mc.forEach(o),Ys=i(G," for more information."),G.forEach(o),Zs=u(Q),$e=r(Q,"DIV",{class:!0});var tr=s($e);P(ht.$$.fragment,tr),ea=u(tr),ft=r(tr,"P",{});var or=s(ft);ta=i(or,"This method forwards all its arguments to Pix2StructTokenizerFast\u2019s "),uo=r(or,"A",{href:!0});var qc=s(uo);oa=i(qc,"batch_decode()"),qc.forEach(o),na=i(or,`.
Please refer to the docstring of this method for more information.`),or.forEach(o),tr.forEach(o),ra=u(Q),Ce=r(Q,"DIV",{class:!0});var nr=s(Ce);P(mt.$$.fragment,nr),sa=u(nr),gt=r(nr,"P",{});var rr=s(gt);aa=i(rr,"This method forwards all its arguments to Pix2StructTokenizerFast\u2019s "),po=r(rr,"A",{href:!0});var Ic=s(po);ia=i(Ic,"decode()"),Ic.forEach(o),ca=i(rr,`. Please
refer to the docstring of this method for more information.`),rr.forEach(o),nr.forEach(o),Q.forEach(o),Dn=u(t),de=r(t,"H2",{class:!0});var sr=s(de);ze=r(sr,"A",{id:!0,class:!0,href:!0});var Fc=s(ze);Yo=r(Fc,"SPAN",{});var jc=s(Yo);P(_t.$$.fragment,jc),jc.forEach(o),Fc.forEach(o),da=u(sr),Zo=r(sr,"SPAN",{});var Ac=s(Zo);la=i(Ac,"Pix2StructImageProcessor"),Ac.forEach(o),sr.forEach(o),On=u(t),R=r(t,"DIV",{class:!0});var yo=s(R);P(xt.$$.fragment,yo),ua=u(yo),en=r(yo,"P",{});var Vc=s(en);pa=i(Vc,"Constructs a Pix2Struct image processor."),Vc.forEach(o),ha=u(yo),Ee=r(yo,"DIV",{class:!0});var ar=s(Ee);P(vt.$$.fragment,ar),fa=u(ar),A=r(ar,"P",{});var Y=s(A);ma=i(Y,`Preprocess an image or batch of images. The processor first computes the maximum possible number of
aspect-ratio preserving patches of size `),tn=r(Y,"CODE",{});var Nc=s(tn);ga=i(Nc,"patch_size"),Nc.forEach(o),_a=i(Y,` that can be extracted from the image. It then pads the
image with zeros to make the image respect the constraint of `),on=r(Y,"CODE",{});var Dc=s(on);xa=i(Dc,"max_patches"),Dc.forEach(o),va=i(Y,`. Before extracting the patches the
images are standardized following the tensorflow implementation of `),nn=r(Y,"CODE",{});var Oc=s(nn);Pa=i(Oc,"per_image_standardization"),Oc.forEach(o),ba=i(Y,`
(`),Pt=r(Y,"A",{href:!0,rel:!0});var Lc=s(Pt);wa=i(Lc,"https://www.tensorflow.org/api_docs/python/tf/image/per_image_standardization"),Lc.forEach(o),Ta=i(Y,")."),Y.forEach(o),ar.forEach(o),yo.forEach(o),Ln=u(t),le=r(t,"H2",{class:!0});var ir=s(le);Me=r(ir,"A",{id:!0,class:!0,href:!0});var Uc=s(Me);rn=r(Uc,"SPAN",{});var Rc=s(rn);P(bt.$$.fragment,Rc),Rc.forEach(o),Uc.forEach(o),ya=u(ir),sn=r(ir,"SPAN",{});var Wc=s(sn);Sa=i(Wc,"Pix2StructTextModel"),Wc.forEach(o),ir.forEach(o),Un=u(t),$=r(t,"DIV",{class:!0});var O=s($);P(wt.$$.fragment,O),ka=u(O),an=r(O,"P",{});var Gc=s(an);$a=i(Gc,"The standalone text decoder of Pix2Struct"),Gc.forEach(o),Ca=u(O),Tt=r(O,"P",{});var cr=s(Tt);za=i(cr,"The Pix2Struct model was proposed in "),yt=r(cr,"A",{href:!0,rel:!0});var Hc=s(yt);Ea=i(Hc,`Pix2Struct: Screenshot Parsing as Pretraining for Visual Language
Understanding`),Hc.forEach(o),Ma=i(cr,` by Kenton Lee, Mandar Joshi, Iulia Turc, Hexiang Hu, Fangyu Liu,
Julian Eisenschlos, Urvashi Khandelwal, Peter Shaw, Ming-Wei Chang, Kristina Toutanova. It\u2019s an encoder decoder
transformer pre-trained in a image-to-text setting.`),cr.forEach(o),qa=u(O),St=r(O,"P",{});var dr=s(St);Ia=i(dr,"This model inherits from "),ho=r(dr,"A",{href:!0});var Bc=s(ho);Fa=i(Bc,"PreTrainedModel"),Bc.forEach(o),ja=i(dr,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),dr.forEach(o),Aa=u(O),kt=r(O,"P",{});var lr=s(kt);Va=i(lr,"This model is also a PyTorch "),$t=r(lr,"A",{href:!0,rel:!0});var Kc=s($t);Na=i(Kc,"torch.nn.Module"),Kc.forEach(o),Da=i(lr,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),lr.forEach(o),Oa=u(O),V=r(O,"DIV",{class:!0});var Re=s(V);P(Ct.$$.fragment,Re),La=u(Re),ue=r(Re,"P",{});var So=s(ue);Ua=i(So,"The "),fo=r(So,"A",{href:!0});var Xc=s(fo);Ra=i(Xc,"Pix2StructTextModel"),Xc.forEach(o),Wa=i(So," forward method, overrides the "),cn=r(So,"CODE",{});var Jc=s(cn);Ga=i(Jc,"__call__"),Jc.forEach(o),Ha=i(So," special method."),So.forEach(o),Ba=u(Re),P(qe.$$.fragment,Re),Ka=u(Re),P(Ie.$$.fragment,Re),Re.forEach(o),O.forEach(o),Rn=u(t),pe=r(t,"H2",{class:!0});var ur=s(pe);Fe=r(ur,"A",{id:!0,class:!0,href:!0});var Qc=s(Fe);dn=r(Qc,"SPAN",{});var Yc=s(dn);P(zt.$$.fragment,Yc),Yc.forEach(o),Qc.forEach(o),Xa=u(ur),ln=r(ur,"SPAN",{});var Zc=s(ln);Ja=i(Zc,"Pix2StructVisionModel"),Zc.forEach(o),ur.forEach(o),Wn=u(t),W=r(t,"DIV",{class:!0});var ko=s(W);P(Et.$$.fragment,ko),Qa=u(ko),Mt=r(ko,"P",{});var pr=s(Mt);Ya=i(pr,`The bare Pix2StructVision Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),qt=r(pr,"A",{href:!0,rel:!0});var ed=s(qt);Za=i(ed,"torch.nn.Module"),ed.forEach(o),ei=i(pr,` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),pr.forEach(o),ti=u(ko),N=r(ko,"DIV",{class:!0});var We=s(N);P(It.$$.fragment,We),oi=u(We),he=r(We,"P",{});var $o=s(he);ni=i($o,"The "),mo=r($o,"A",{href:!0});var td=s(mo);ri=i(td,"Pix2StructVisionModel"),td.forEach(o),si=i($o," forward method, overrides the "),un=r($o,"CODE",{});var od=s(un);ai=i(od,"__call__"),od.forEach(o),ii=i($o," special method."),$o.forEach(o),ci=u(We),P(je.$$.fragment,We),di=u(We),P(Ae.$$.fragment,We),We.forEach(o),ko.forEach(o),Gn=u(t),fe=r(t,"H2",{class:!0});var hr=s(fe);Ve=r(hr,"A",{id:!0,class:!0,href:!0});var nd=s(Ve);pn=r(nd,"SPAN",{});var rd=s(pn);P(Ft.$$.fragment,rd),rd.forEach(o),nd.forEach(o),li=u(hr),hn=r(hr,"SPAN",{});var sd=s(hn);ui=i(sd,"Pix2StructForConditionalGeneration"),sd.forEach(o),hr.forEach(o),Hn=u(t),C=r(t,"DIV",{class:!0});var L=s(C);P(jt.$$.fragment,L),pi=u(L),fn=r(L,"P",{});var ad=s(fn);hi=i(ad,"A conditional generation model with a language modeling head. Can be used for sequence generation tasks."),ad.forEach(o),fi=u(L),At=r(L,"P",{});var fr=s(At);mi=i(fr,"The Pix2Struct model was proposed in "),Vt=r(fr,"A",{href:!0,rel:!0});var id=s(Vt);gi=i(id,`Pix2Struct: Screenshot Parsing as Pretraining for Visual Language
Understanding`),id.forEach(o),_i=i(fr,` by Kenton Lee, Mandar Joshi, Iulia Turc, Hexiang Hu, Fangyu Liu,
Julian Eisenschlos, Urvashi Khandelwal, Peter Shaw, Ming-Wei Chang, Kristina Toutanova. It\u2019s an encoder decoder
transformer pre-trained in a image-to-text setting.`),fr.forEach(o),xi=u(L),Nt=r(L,"P",{});var mr=s(Nt);vi=i(mr,"This model inherits from "),go=r(mr,"A",{href:!0});var cd=s(go);Pi=i(cd,"PreTrainedModel"),cd.forEach(o),bi=i(mr,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),mr.forEach(o),wi=u(L),Dt=r(L,"P",{});var gr=s(Dt);Ti=i(gr,"This model is also a PyTorch "),Ot=r(gr,"A",{href:!0,rel:!0});var dd=s(Ot);yi=i(dd,"torch.nn.Module"),dd.forEach(o),Si=i(gr,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),gr.forEach(o),ki=u(L),D=r(L,"DIV",{class:!0});var Ge=s(D);P(Lt.$$.fragment,Ge),$i=u(Ge),me=r(Ge,"P",{});var Co=s(me);Ci=i(Co,"The "),_o=r(Co,"A",{href:!0});var ld=s(_o);zi=i(ld,"Pix2StructForConditionalGeneration"),ld.forEach(o),Ei=i(Co," forward method, overrides the "),mn=r(Co,"CODE",{});var ud=s(mn);Mi=i(ud,"__call__"),ud.forEach(o),qi=i(Co," special method."),Co.forEach(o),Ii=u(Ge),P(Ne.$$.fragment,Ge),Fi=u(Ge),P(De.$$.fragment,Ge),Ge.forEach(o),L.forEach(o),this.h()},h(){d(p,"name","hf:doc:metadata"),d(p,"content",JSON.stringify($d)),d(f,"id","pix2struct"),d(f,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(f,"href","#pix2struct"),d(_,"class","relative group"),d(ge,"id","overview"),d(ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ge,"href","#overview"),d(Z,"class","relative group"),d(Be,"href","https://arxiv.org/abs/2210.03347"),d(Be,"rel","nofollow"),d(Ke,"href","https://huggingface.co/ybelkada"),d(Ke,"rel","nofollow"),d(Xe,"href","https://github.com/google-research/pix2struct"),d(Xe,"rel","nofollow"),d(xe,"id","resources"),d(xe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(xe,"href","#resources"),d(ee,"class","relative group"),d(Qe,"href","https://arxiv.org/abs/2210.03347"),d(Qe,"rel","nofollow"),d(Ye,"href","https://github.com/huggingface/notebooks/blob/main/examples/image_captioning_pix2struct.ipynb"),d(Ye,"rel","nofollow"),d(Ze,"href","https://huggingface.co/models?search=pix2struct"),d(Ze,"rel","nofollow"),d(ve,"id","transformers.Pix2StructConfig"),d(ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ve,"href","#transformers.Pix2StructConfig"),d(te,"class","relative group"),d(Jt,"href","/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructConfig"),d(ot,"href","https://huggingface.co/Salesforce/pix2struct-vqa-base"),d(ot,"rel","nofollow"),d(Qt,"href","/docs/transformers/pr_22365/en/main_classes/configuration#transformers.PretrainedConfig"),d(Yt,"href","/docs/transformers/pr_22365/en/main_classes/configuration#transformers.PretrainedConfig"),d(Zt,"href","/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructConfig"),d(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(we,"id","transformers.Pix2StructTextConfig"),d(we,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(we,"href","#transformers.Pix2StructTextConfig"),d(ne,"class","relative group"),d(eo,"href","/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructTextModel"),d(it,"href","https://huggingface.co/google/pix2struct-textcaps-base"),d(it,"rel","nofollow"),d(to,"href","/docs/transformers/pr_22365/en/main_classes/configuration#transformers.PretrainedConfig"),d(oo,"href","/docs/transformers/pr_22365/en/main_classes/configuration#transformers.PretrainedConfig"),d(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ye,"id","transformers.Pix2StructVisionConfig"),d(ye,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ye,"href","#transformers.Pix2StructVisionConfig"),d(se,"class","relative group"),d(no,"href","/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructVisionModel"),d(lt,"href","https://huggingface.co/Salesforce/pix2struct-vqa-base"),d(lt,"rel","nofollow"),d(ro,"href","/docs/transformers/pr_22365/en/main_classes/configuration#transformers.PretrainedConfig"),d(so,"href","/docs/transformers/pr_22365/en/main_classes/configuration#transformers.PretrainedConfig"),d(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ke,"id","transformers.Pix2StructProcessor"),d(ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ke,"href","#transformers.Pix2StructProcessor"),d(ce,"class","relative group"),d(ao,"href","/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructProcessor"),d(io,"href","/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructImageProcessor"),d(co,"href","/docs/transformers/pr_22365/en/model_doc/mt5#transformers.T5TokenizerFast"),d(lo,"href","/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructProcessor.decode"),d(uo,"href","/docs/transformers/pr_22365/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.batch_decode"),d($e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(po,"href","/docs/transformers/pr_22365/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.decode"),d(Ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ze,"id","transformers.Pix2StructImageProcessor"),d(ze,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ze,"href","#transformers.Pix2StructImageProcessor"),d(de,"class","relative group"),d(Pt,"href","https://www.tensorflow.org/api_docs/python/tf/image/per_image_standardization"),d(Pt,"rel","nofollow"),d(Ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Me,"id","transformers.Pix2StructTextModel"),d(Me,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Me,"href","#transformers.Pix2StructTextModel"),d(le,"class","relative group"),d(yt,"href","https://arxiv.org/abs/2210.03347"),d(yt,"rel","nofollow"),d(ho,"href","/docs/transformers/pr_22365/en/main_classes/model#transformers.PreTrainedModel"),d($t,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),d($t,"rel","nofollow"),d(fo,"href","/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructTextModel"),d(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Fe,"id","transformers.Pix2StructVisionModel"),d(Fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Fe,"href","#transformers.Pix2StructVisionModel"),d(pe,"class","relative group"),d(qt,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),d(qt,"rel","nofollow"),d(mo,"href","/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructVisionModel"),d(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ve,"id","transformers.Pix2StructForConditionalGeneration"),d(Ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Ve,"href","#transformers.Pix2StructForConditionalGeneration"),d(fe,"class","relative group"),d(Vt,"href","https://arxiv.org/abs/2210.03347"),d(Vt,"rel","nofollow"),d(go,"href","/docs/transformers/pr_22365/en/main_classes/model#transformers.PreTrainedModel"),d(Ot,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),d(Ot,"rel","nofollow"),d(_o,"href","/docs/transformers/pr_22365/en/model_doc/pix2struct#transformers.Pix2StructForConditionalGeneration"),d(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,h){e(document.head,p),m(t,S,h),m(t,_,h),e(_,f),e(f,x),b(c,x,null),e(_,g),e(_,q),e(q,_r),m(t,wn,h),m(t,Z,h),e(Z,ge),e(ge,qo),b(He,qo,null),e(Z,xr),e(Z,Io),e(Io,vr),m(t,Tn,h),m(t,_e,h),e(_e,Pr),e(_e,Be),e(Be,br),e(_e,wr),m(t,yn,h),m(t,Ht,h),e(Ht,Tr),m(t,Sn,h),m(t,Bt,h),e(Bt,Fo),e(Fo,yr),m(t,kn,h),m(t,Kt,h),e(Kt,Sr),m(t,$n,h),m(t,Xt,h),e(Xt,kr),m(t,Cn,h),m(t,B,h),e(B,$r),e(B,Ke),e(Ke,Cr),e(B,zr),e(B,Xe),e(Xe,Er),e(B,Mr),m(t,zn,h),m(t,ee,h),e(ee,xe),e(xe,jo),b(Je,jo,null),e(ee,qr),e(ee,Ao),e(Ao,Ir),m(t,En,h),m(t,K,h),e(K,Vo),e(Vo,Qe),e(Qe,Fr),e(K,jr),e(K,No),e(No,Ye),e(Ye,Ar),e(K,Vr),e(K,Do),e(Do,Ze),e(Ze,Nr),m(t,Mn,h),m(t,te,h),e(te,ve),e(ve,Oo),b(et,Oo,null),e(te,Dr),e(te,Lo),e(Lo,Or),m(t,qn,h),m(t,z,h),b(tt,z,null),e(z,Lr),e(z,X),e(X,Jt),e(Jt,Ur),e(X,Rr),e(X,Uo),e(Uo,Wr),e(X,Gr),e(X,ot),e(ot,Hr),e(X,Br),e(z,Kr),e(z,oe),e(oe,Xr),e(oe,Qt),e(Qt,Jr),e(oe,Qr),e(oe,Yt),e(Yt,Yr),e(oe,Zr),e(z,es),b(Pe,z,null),e(z,ts),e(z,be),b(nt,be,null),e(be,os),e(be,rt),e(rt,ns),e(rt,Zt),e(Zt,rs),e(rt,ss),m(t,In,h),m(t,ne,h),e(ne,we),e(we,Ro),b(st,Ro,null),e(ne,as),e(ne,Wo),e(Wo,is),m(t,Fn,h),m(t,F,h),b(at,F,null),e(F,cs),e(F,U),e(U,ds),e(U,eo),e(eo,ls),e(U,us),e(U,Go),e(Go,ps),e(U,hs),e(U,it),e(it,fs),e(U,ms),e(F,gs),e(F,re),e(re,_s),e(re,to),e(to,xs),e(re,vs),e(re,oo),e(oo,Ps),e(re,bs),e(F,ws),b(Te,F,null),m(t,jn,h),m(t,se,h),e(se,ye),e(ye,Ho),b(ct,Ho,null),e(se,Ts),e(se,Bo),e(Bo,ys),m(t,An,h),m(t,j,h),b(dt,j,null),e(j,Ss),e(j,ae),e(ae,ks),e(ae,no),e(no,$s),e(ae,Cs),e(ae,lt),e(lt,zs),e(ae,Es),e(j,Ms),e(j,ie),e(ie,qs),e(ie,ro),e(ro,Is),e(ie,Fs),e(ie,so),e(so,js),e(ie,As),e(j,Vs),b(Se,j,null),m(t,Vn,h),m(t,ce,h),e(ce,ke),e(ke,Ko),b(ut,Ko,null),e(ce,Ns),e(ce,Xo),e(Xo,Ds),m(t,Nn,h),m(t,E,h),b(pt,E,null),e(E,Os),e(E,Jo),e(Jo,Ls),e(E,Us),e(E,I),e(I,ao),e(ao,Rs),e(I,Ws),e(I,io),e(io,Gs),e(I,Hs),e(I,co),e(co,Bs),e(I,Ks),e(I,Qo),e(Qo,Xs),e(I,Js),e(I,lo),e(lo,Qs),e(I,Ys),e(E,Zs),e(E,$e),b(ht,$e,null),e($e,ea),e($e,ft),e(ft,ta),e(ft,uo),e(uo,oa),e(ft,na),e(E,ra),e(E,Ce),b(mt,Ce,null),e(Ce,sa),e(Ce,gt),e(gt,aa),e(gt,po),e(po,ia),e(gt,ca),m(t,Dn,h),m(t,de,h),e(de,ze),e(ze,Yo),b(_t,Yo,null),e(de,da),e(de,Zo),e(Zo,la),m(t,On,h),m(t,R,h),b(xt,R,null),e(R,ua),e(R,en),e(en,pa),e(R,ha),e(R,Ee),b(vt,Ee,null),e(Ee,fa),e(Ee,A),e(A,ma),e(A,tn),e(tn,ga),e(A,_a),e(A,on),e(on,xa),e(A,va),e(A,nn),e(nn,Pa),e(A,ba),e(A,Pt),e(Pt,wa),e(A,Ta),m(t,Ln,h),m(t,le,h),e(le,Me),e(Me,rn),b(bt,rn,null),e(le,ya),e(le,sn),e(sn,Sa),m(t,Un,h),m(t,$,h),b(wt,$,null),e($,ka),e($,an),e(an,$a),e($,Ca),e($,Tt),e(Tt,za),e(Tt,yt),e(yt,Ea),e(Tt,Ma),e($,qa),e($,St),e(St,Ia),e(St,ho),e(ho,Fa),e(St,ja),e($,Aa),e($,kt),e(kt,Va),e(kt,$t),e($t,Na),e(kt,Da),e($,Oa),e($,V),b(Ct,V,null),e(V,La),e(V,ue),e(ue,Ua),e(ue,fo),e(fo,Ra),e(ue,Wa),e(ue,cn),e(cn,Ga),e(ue,Ha),e(V,Ba),b(qe,V,null),e(V,Ka),b(Ie,V,null),m(t,Rn,h),m(t,pe,h),e(pe,Fe),e(Fe,dn),b(zt,dn,null),e(pe,Xa),e(pe,ln),e(ln,Ja),m(t,Wn,h),m(t,W,h),b(Et,W,null),e(W,Qa),e(W,Mt),e(Mt,Ya),e(Mt,qt),e(qt,Za),e(Mt,ei),e(W,ti),e(W,N),b(It,N,null),e(N,oi),e(N,he),e(he,ni),e(he,mo),e(mo,ri),e(he,si),e(he,un),e(un,ai),e(he,ii),e(N,ci),b(je,N,null),e(N,di),b(Ae,N,null),m(t,Gn,h),m(t,fe,h),e(fe,Ve),e(Ve,pn),b(Ft,pn,null),e(fe,li),e(fe,hn),e(hn,ui),m(t,Hn,h),m(t,C,h),b(jt,C,null),e(C,pi),e(C,fn),e(fn,hi),e(C,fi),e(C,At),e(At,mi),e(At,Vt),e(Vt,gi),e(At,_i),e(C,xi),e(C,Nt),e(Nt,vi),e(Nt,go),e(go,Pi),e(Nt,bi),e(C,wi),e(C,Dt),e(Dt,Ti),e(Dt,Ot),e(Ot,yi),e(Dt,Si),e(C,ki),e(C,D),b(Lt,D,null),e(D,$i),e(D,me),e(me,Ci),e(me,_o),e(_o,zi),e(me,Ei),e(me,mn),e(mn,Mi),e(me,qi),e(D,Ii),b(Ne,D,null),e(D,Fi),b(De,D,null),Bn=!0},p(t,[h]){const Ut={};h&2&&(Ut.$$scope={dirty:h,ctx:t}),Pe.$set(Ut);const gn={};h&2&&(gn.$$scope={dirty:h,ctx:t}),Te.$set(gn);const _n={};h&2&&(_n.$$scope={dirty:h,ctx:t}),Se.$set(_n);const xn={};h&2&&(xn.$$scope={dirty:h,ctx:t}),qe.$set(xn);const Rt={};h&2&&(Rt.$$scope={dirty:h,ctx:t}),Ie.$set(Rt);const vn={};h&2&&(vn.$$scope={dirty:h,ctx:t}),je.$set(vn);const Pn={};h&2&&(Pn.$$scope={dirty:h,ctx:t}),Ae.$set(Pn);const bn={};h&2&&(bn.$$scope={dirty:h,ctx:t}),Ne.$set(bn);const Wt={};h&2&&(Wt.$$scope={dirty:h,ctx:t}),De.$set(Wt)},i(t){Bn||(w(c.$$.fragment,t),w(He.$$.fragment,t),w(Je.$$.fragment,t),w(et.$$.fragment,t),w(tt.$$.fragment,t),w(Pe.$$.fragment,t),w(nt.$$.fragment,t),w(st.$$.fragment,t),w(at.$$.fragment,t),w(Te.$$.fragment,t),w(ct.$$.fragment,t),w(dt.$$.fragment,t),w(Se.$$.fragment,t),w(ut.$$.fragment,t),w(pt.$$.fragment,t),w(ht.$$.fragment,t),w(mt.$$.fragment,t),w(_t.$$.fragment,t),w(xt.$$.fragment,t),w(vt.$$.fragment,t),w(bt.$$.fragment,t),w(wt.$$.fragment,t),w(Ct.$$.fragment,t),w(qe.$$.fragment,t),w(Ie.$$.fragment,t),w(zt.$$.fragment,t),w(Et.$$.fragment,t),w(It.$$.fragment,t),w(je.$$.fragment,t),w(Ae.$$.fragment,t),w(Ft.$$.fragment,t),w(jt.$$.fragment,t),w(Lt.$$.fragment,t),w(Ne.$$.fragment,t),w(De.$$.fragment,t),Bn=!0)},o(t){T(c.$$.fragment,t),T(He.$$.fragment,t),T(Je.$$.fragment,t),T(et.$$.fragment,t),T(tt.$$.fragment,t),T(Pe.$$.fragment,t),T(nt.$$.fragment,t),T(st.$$.fragment,t),T(at.$$.fragment,t),T(Te.$$.fragment,t),T(ct.$$.fragment,t),T(dt.$$.fragment,t),T(Se.$$.fragment,t),T(ut.$$.fragment,t),T(pt.$$.fragment,t),T(ht.$$.fragment,t),T(mt.$$.fragment,t),T(_t.$$.fragment,t),T(xt.$$.fragment,t),T(vt.$$.fragment,t),T(bt.$$.fragment,t),T(wt.$$.fragment,t),T(Ct.$$.fragment,t),T(qe.$$.fragment,t),T(Ie.$$.fragment,t),T(zt.$$.fragment,t),T(Et.$$.fragment,t),T(It.$$.fragment,t),T(je.$$.fragment,t),T(Ae.$$.fragment,t),T(Ft.$$.fragment,t),T(jt.$$.fragment,t),T(Lt.$$.fragment,t),T(Ne.$$.fragment,t),T(De.$$.fragment,t),Bn=!1},d(t){o(p),t&&o(S),t&&o(_),y(c),t&&o(wn),t&&o(Z),y(He),t&&o(Tn),t&&o(_e),t&&o(yn),t&&o(Ht),t&&o(Sn),t&&o(Bt),t&&o(kn),t&&o(Kt),t&&o($n),t&&o(Xt),t&&o(Cn),t&&o(B),t&&o(zn),t&&o(ee),y(Je),t&&o(En),t&&o(K),t&&o(Mn),t&&o(te),y(et),t&&o(qn),t&&o(z),y(tt),y(Pe),y(nt),t&&o(In),t&&o(ne),y(st),t&&o(Fn),t&&o(F),y(at),y(Te),t&&o(jn),t&&o(se),y(ct),t&&o(An),t&&o(j),y(dt),y(Se),t&&o(Vn),t&&o(ce),y(ut),t&&o(Nn),t&&o(E),y(pt),y(ht),y(mt),t&&o(Dn),t&&o(de),y(_t),t&&o(On),t&&o(R),y(xt),y(vt),t&&o(Ln),t&&o(le),y(bt),t&&o(Un),t&&o($),y(wt),y(Ct),y(qe),y(Ie),t&&o(Rn),t&&o(pe),y(zt),t&&o(Wn),t&&o(W),y(Et),y(It),y(je),y(Ae),t&&o(Gn),t&&o(fe),y(Ft),t&&o(Hn),t&&o(C),y(jt),y(Lt),y(Ne),y(De)}}}const $d={local:"pix2struct",sections:[{local:"overview",title:"Overview"},{local:"resources",title:"Resources:"},{local:"transformers.Pix2StructConfig",title:"Pix2StructConfig"},{local:"transformers.Pix2StructTextConfig",title:"Pix2StructTextConfig"},{local:"transformers.Pix2StructVisionConfig",title:"Pix2StructVisionConfig"},{local:"transformers.Pix2StructProcessor",title:"Pix2StructProcessor"},{local:"transformers.Pix2StructImageProcessor",title:"Pix2StructImageProcessor"},{local:"transformers.Pix2StructTextModel",title:"Pix2StructTextModel"},{local:"transformers.Pix2StructVisionModel",title:"Pix2StructVisionModel"},{local:"transformers.Pix2StructForConditionalGeneration",title:"Pix2StructForConditionalGeneration"}],title:"Pix2Struct"};function Cd(k){return gd(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class jd extends pd{constructor(p){super();hd(this,p,Cd,kd,fd,{})}}export{jd as default,$d as metadata};
